// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/async/api/main.h $
// $Rev: 50130 $
// $Date: 2022-02-04 09:01:53 -0600 (Fri, 04 Feb 2022) $

// SIO4: Asychronous Protocol Library: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <errno.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>

#include "sio4_dsl.h"
#include "sio4_utils.h"
#include "sio4_async.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)		(sizeof((a))/sizeof((a)[0]))

#undef	ERROR



// data types *****************************************************************

typedef struct
{
	os_sem_t		sem;
	int				fd;
	int				users;
	int				z16c30;

} async_device_t;



// prototypes *****************************************************************

async_device_t*	async_lib_dev_alloc(void);						// returns NULL or valid pointer
void			async_lib_dev_free(async_device_t* dev);			// Caller must hold lock!
int				async_lib_dev_lock(void);
void			async_lib_dev_unlock(void);
int				async_lib_fd_dec(async_device_t* dev);			// returns 0 or -errno
int				async_lib_fd_inc(int fd, async_device_t** dev);	// returns 0 or -errno
int				async_lib_init_verify(const char** err);

int				async_show_fprintf(FILE* file, const char* format, ... );	// returns error count
int				async_show_label(FILE* file, const char* label);			// returns error count

int				sio4_async_t_access(async_device_t* dev, sio4_async_t* async, sio4_async_action_t action, const char** err, FILE* file);



#endif
