// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/async/samples/rxasync/main.h $
// $Rev: 53128 $
// $Date: 2023-06-16 15:09:50 -0500 (Fri, 16 Jun 2023) $

// SIO4: Asynchronous Protocol Library: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <ctype.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "sio4_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)				(sizeof((a)) / sizeof((a)[0]))



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of boards detected.
	s32	skip;			// Skip testing due to firmware type?
	s32	test_limit;		// for continuous testing
	s32	verbose;		// Work verbosely?

	int	fd;				// File descriptor for device to access.

	// Device Settings

	s32	pc;
	s32	print;
	s32	save;
	s32	seconds;		// Read data for this long.
	s32	term_res;		// Enable termination resistors?
	s32	xcvr;
} args_t;



// prototypes *****************************************************************

int		perform_tests(const args_t* args, int* skip);



#endif
