// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/async/utils/async_read_util.c $
// $Rev: 53121 $
// $Date: 2023-06-16 15:03:34 -0500 (Fri, 16 Jun 2023) $

// SIO4: Asynchronous Protocol Library: Utilities: source file

#include "main.h"



//*****************************************************************************
int async_read_util(int fd, int index, int verbose, void* dst, size_t bytes, size_t* got)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Asynchronous Reading", index);

	ret		= sio4_async_read(fd, dst, bytes);
	errs	= (ret < 0) ? 1 : 0;

	if (verbose == 0)
	{
	}
	else if (ret >= 0)
	{
		printf("PASS  (%d Byte%s)\n", ret, (ret == 1) ? "" : "s");
	}
	else
	{
		printf(	"FAIL <---  (requested %ld Byte%s, ret = %ld)\n",
				(long) bytes,
				(bytes == 1) ? "" : "s",
				(long) ret);
	}

	if (got)
		got[0]	= (ret >= 0) ? ret : 0;

	return(errs);
}


