// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/driver/open.c $
// $Rev: 54312 $
// $Date: 2024-03-19 10:50:21 -0500 (Tue, 19 Mar 2024) $

// SIO4: Device Driver: source file

#include "main.h"



//*****************************************************************************
int dev_open(chan_data_t* chan)
{
	dev_data_t*	dev		= chan->dev;
	u32			mask;
	int			ret;

	ret	= dev_io_open(chan);

	if (ret == 0)
		ret	= gsc_dma_open(chan->dev, chan->index);

	if (ret == 0)
		ret	= gsc_irq_open(dev, chan->index);

	if (ret == 0)
	{
		mp_open(chan);
		osc_open(chan);
		mask	= 0xFF < (chan->index  * 8);

		if (dev->cache.model_z16c30)
			os_reg_mem_mx_u32(dev, dev->vaddr.gsc_ftr_32, 0x01010101, mask);
		else if (dev->cache.model_sync)
			os_reg_mem_mx_u32(dev, dev->vaddr.gsc_ftr_32, 0x04040404, mask);
		else if (dev->cache.model_fasync)
			os_reg_mem_mx_u32(dev, dev->vaddr.gsc_ftr_32, 0x08080808, mask);

		initialize_ioctl(chan, NULL);
	}

	if (ret)
		dev_close(chan);

	return(ret);
}


