// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/fasync/api/error.c $
// $Rev: 54330 $
// $Date: 2024-03-22 11:04:01 -0500 (Fri, 22 Mar 2024) $

// SIO4: Fast Async Protocol Library: source file

#include "main.h"



//*****************************************************************************
sio4_fasync_error_t* fasync_error_ptr_valid(
	sio4_fasync_error_t*	error,
	sio4_fasync_error_t*	e_alt)
{
	if (error == NULL)
	{
		error	= e_alt;

		if (error)
			memset(error, 0, sizeof(sio4_fasync_error_t));
	}
	else if (error->ret == 0)
	{
		memset(error, 0, sizeof(sio4_fasync_error_t));
	}

	return(error);
}



//*****************************************************************************
void fasync_error_update(
	const fasync_device_t*	dev,
	sio4_fasync_error_t*	error,
	int						ret_new,
	const char*				msg,
	const char*				file,
	const char*				function,
	int						line)
{
	if ((error->ret == 0) && (ret_new))
	{
		error->ret		= ret_new;
		strncpy(error->msg, msg, sizeof(error->msg));
		error->msg[sizeof(error->msg) - 1]	= 0;

		error->name		= dev->name;
		error->file		= file;
		error->function	= function;
		error->line		= line;
	}
}


