// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/fasync/api/tx_fifo_reset.c $
// $Rev: 54330 $
// $Date: 2024-03-22 11:04:01 -0500 (Fri, 22 Mar 2024) $

// SIO4: Fast Async Protocol Library: source file

#include "main.h"



// macros *********************************************************************

#define	NAME	"sio4_fasync_tx_fifo_reset()"



//*****************************************************************************
int fasync_tx_fifo_reset(fasync_device_t* dev, sio4_fasync_error_t* error)
{
	char	buf[80];
	int		ret;
	s32		set;

	set	= 1;
	sprintf(buf, "IOCTL service failure: SIO4_IOCTL_TX_FIFO_RESET, set %d", set);
	ret	= sio4_ioctl(dev->fd, SIO4_IOCTL_TX_FIFO_RESET, &set);
	ERROR_UPDATE(dev, error, ret, buf);
	return(ret);
}



//*****************************************************************************
// Returns: 0 or -errno
int sio4_fasync_tx_fifo_reset(int fd, sio4_fasync_error_t* error)
{
	fasync_device_t		d_tmp;
	fasync_device_t*	dev;
	sio4_fasync_error_t	e_tmp;
	fasync_lock_t		lock	= FASYNC_LOCK_DEVICE;
	int					ret;
	int					tmp;

	memset(&d_tmp, 0, sizeof(fasync_device_t));
	dev			= &d_tmp;
	dev->name	= NAME;
	error		= fasync_error_ptr_valid(error, &e_tmp);
	ret			= fasync_api_enter(fd, &dev, error, 0, lock);

	if (ret == 0)
	{
		ret	= fasync_tx_fifo_reset(dev, error);
		tmp	= fasync_api_exit(dev, error, lock);
		ret	= ret ? ret : tmp;
	}

	return(ret);
}


