// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/fasync/api/verify_util.c $
// $Rev: 54330 $
// $Date: 2024-03-22 11:04:01 -0500 (Fri, 22 Mar 2024) $

// SIO4: Fast Async Protocol Library: source file

#include "main.h"



//*****************************************************************************
int fasync_verify_entry_list(
	const fasync_device_t*			dev,
	sio4_fasync_error_t*			error,
	s32								set,
	const fasync_option_entry_t*	entry)
{
	int	i;
	int	ret	= 0;

	for (i = 0;; i++)
	{
		if (set == entry[i].value)
			break;

		if (entry[i].value == -1)
		{
			ret	= -EINVAL;
			ERROR_UPDATE(dev, error, ret, "Invalid value");
			break;
		}
	}

	return(ret);
}



//*****************************************************************************
int fasync_verify_mask(
	const fasync_device_t*	dev,
	sio4_fasync_error_t*	error,
	s32						set,
	u32						mask)
{
	int	ret	= 0;

	if (set == -1)
	{
	}
	else if (set & ~mask)
	{
		ret	= -EINVAL;
		ERROR_UPDATE(dev, error, ret, "Invalid value");
	}

	return(ret);
}



//*****************************************************************************
int fasync_verify_range(
	const fasync_device_t*			dev,
	sio4_fasync_error_t*			error,
	s32								set,
	const fasync_option_range_t*	range)
{
	int	ret	= 0;

	if (set == -1)
	{
	}
	else if ((set < range->min) || (set > range->max))
	{
		ret	= -EINVAL;
		ERROR_UPDATE(dev, error, ret, "Invalid value");
	}

	return(ret);
}


