// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/fasync/samples/din/main.h $
// $Rev: 54330 $
// $Date: 2024-03-22 11:04:01 -0500 (Fri, 22 Mar 2024) $

// SIO4: Fast Async Protocol Library: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "sio4_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))

#define	D4						(1 << 4)
#define	D5						(1 << 5)
#define	D6						(1 << 6)
#define	D7						(1 << 7)

#define	DCE						SIO4_FASYNC_CABLE_MODE_DCE
#define	DTE						SIO4_FASYNC_CABLE_MODE_DTE



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	s32	ms_wait;		// Wait this long after each output.
	int	qty;			// Number of devices detected.
	s32	seconds;		// Monitor the inputs for this long.
	s32	skip;			// Skip testing due to wrong firmware type?
	s32	test_limit;		// for continuous testing

	int	fd;				// File descriptor for device to access.

	// Device Settings

	s32	cable_mode;		// DCE/DTE

} args_t;



// prototypes *****************************************************************

int	perform_tests(const args_t* args, int* skip);



#endif
