// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/fasync/samples/fasyncc2c/perform.c $
// $Rev: 54330 $
// $Date: 2024-03-22 11:04:01 -0500 (Fri, 22 Mar 2024) $

// SIO4: Fast Async Protocol Library: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _verify_model(const args_t* args, int* skip)
{
	int	errs		= 0;
	s32	fasync_rx;
	s32	fasync_tx;

	if (args->rx_index == args->tx_index)
	{
		errs	+= sio4_query(args->tx_fd, -1, 1, SIO4_QUERY_MODEL_FASYNC, &fasync_tx);

		if (errs)
		{
			skip[0]	= 1;
		}
		else if (fasync_tx)
		{
			skip[0]	= 0;
		}
		else
		{
			skip[0]	= 1;
			gsc_label(NULL);
			printf("SKIP  (Not a Fast Async model SIO4.)\n");
		}
	}
	else
	{
		errs	+= sio4_query(args->tx_fd, args->tx_index, 1, SIO4_QUERY_MODEL_FASYNC, &fasync_tx);
		errs	+= sio4_query(args->rx_fd, args->rx_index, 1, SIO4_QUERY_MODEL_FASYNC, &fasync_rx);

		if (errs)
		{
			skip[0]	= 1;
		}
		else if ((fasync_tx) && (fasync_rx))
		{
			skip[0]	= 0;
		}
		else
		{
			skip[0]	= 1;

			if (fasync_tx == 0)
			{
				gsc_label(NULL);
				printf("SKIP  (Tx device is not a Fast Async model SIO4.)\n");
			}

			if (fasync_rx == 0)
			{
				gsc_label(NULL);
				printf("SKIP  (Rx device is not a Fast Async model SIO4.)\n");
			}
		}
	}

	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args, int* skip)
{
	int			errs		= 0;
	io_stats_t	io_stats;

	for (;;)	// A covenience loop.
	{
		errs	= _verify_model(args, skip);

		if ((errs) || (skip[0]))
			break;

		// Begin Testing ==================================

		gsc_label("Data I/O Test");
		printf("\n");
		gsc_label_level_inc();

		stats_init(&io_stats);

		errs	= config_test(args);

		if ((skip[0] == 0) && (errs == 0))
			errs	= transfer_test(args, &io_stats);

		gsc_label_level_dec();

		errs	+= stats_report(&io_stats);
		break;
	}

	return(errs);
}


