// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/fasync/samples/gpio/config.c $
// $Rev: 54330 $
// $Date: 2024-03-22 11:04:01 -0500 (Fri, 22 Mar 2024) $

// SIO4: Fast Async Protocol Library: Sample Application: source file

#include "main.h"



//*****************************************************************************
int config(const args_t* args, const setup_t* setup)
{
	sio4_fasync_error_t	error;
	int					errs	= 0;
	sio4_fasync_t		fasync;
	sio4_fasync_init_t	init;
	int					ret;

	for (;;)	// A convenience loop.
	{
		gsc_label("Setup");

		memset(&error, 0, sizeof(sio4_fasync_error_t));
		memset(&init, 0, sizeof(sio4_fasync_init_t));
		memset(&fasync, 0, sizeof(sio4_fasync_t));

		init.bitrate	= 100000;

		ret	= sio4_fasync_init_data(args->fd, &init, &fasync, &error);

		if (ret)
		{
			errs	= 1;
			printf("FAIL <---  (sio4_fasync_init_data(): %s)\n", error.msg);
			break;
		}

		if (setup->cable_mode >= 0)
			fasync.cable.mode	= setup->cable_mode;

		fasync.cable.loopback	= SIO4_FASYNC_CABLE_LOOPBACK_EXT;
		// For now CTS must be set to AUTO. This ay change in the future.
		fasync.tx.cts			= SIO4_FASYNC_TX_CTS_IN_AUTO_TX;

		ret	= sio4_fasync_set(args->fd, &fasync, &error);

		if (ret)
		{
			errs	= 1;
			printf("FAIL <---  (sio4_fasync_set(): %s)\n", error.msg);
			break;
		}

		printf("PASS\n");
		break;
	}

	return(errs);
}


