// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/fasync/samples/gpio/main.h $
// $Rev: 54330 $
// $Date: 2024-03-22 11:04:01 -0500 (Fri, 22 Mar 2024) $

// SIO4: Fast Async Protocol Library: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include "sio4_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)				(sizeof((a)) / sizeof((a)[0]))

#define	D0							(1 << 0)
#define	D1							(1 << 1)
#define	D2							(1 << 2)
#define	D3							(1 << 3)
#define	D4							(1 << 4)
#define	D5							(1 << 5)
#define	D6							(1 << 6)
#define	D7							(1 << 7)
#define	D8							(1 << 8)
#define	D9							(1 << 9)
#define	D10							(1 << 10)
#define	D11							(1 << 11)
#define	D12							(1 << 12)
#define	D28							(1 << 28)



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of boards detected.
	s32	skip;			// Skip testing due to wrong firmware type?
	s32	test_limit;		// for continuous testing
	s32	verbose;		// generate additional output?

	int	fd;				// File descriptor for device to access.

	// Device Settings

} args_t;

typedef struct
{
	s32		arg;
	s32		reg;
	u32		mask;
	u32		value;
} level_output_t;

typedef struct
{
	s32		reg;
	u32		mask;
	u32		value;
} level_input_t;

typedef struct
{
	const char*	name;
	s32			cable_mode;	// -1 = ignore this field
	int			(*func)(int fd, s32* arg, sio4_fasync_action_t action, FILE* file, sio4_fasync_error_t* error);

	struct
	{
		level_output_t	output;
		level_input_t	input;
	} level[2];	// 0 = low outut settings, 1 = high outut settings

} setup_t;



// prototypes *****************************************************************

int	config(const args_t* args, const setup_t* setup);

int	gpio_test(const args_t* args, const setup_t* setup);

int	perform_tests(const args_t* args, int* skip);



#endif
