// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/fasync/utils/open_util.c $
// $Rev: 54330 $
// $Date: 2024-03-22 11:04:01 -0500 (Fri, 22 Mar 2024) $

// SIO4: Fast Async Protocol Library: Utilities: source file

#include "main.h"



//*****************************************************************************
int fasync_open_util(
	int						device,
	int						share,
	int						index,
	int						verbose,
	int*					fd,
	sio4_fasync_error_t*	error)
{
	const char*	access	= share ? "Share" : "Exclusive";
	int			board	= device / 4;
	int			chan	= device % 4;
	int			errs;
	int			ret;

	if (verbose)
		gsc_label_index("Fast Async Open", index);

	ret		= sio4_fasync_open(device, share, fd, error);
	errs	= (ret < 0) ? 1 : 0;

	if (verbose == 0)
		;
	else if (errs)
		printf("FAIL <---  (sio4_fasync_open(): ret = %d)\n", ret);
	else
		printf("PASS  (%s, board %d, channel %d)\n", access, board, chan);

	return(errs);
}


