// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/fasync/utils/show_util.c $
// $Rev: 54330 $
// $Date: 2024-03-22 11:04:01 -0500 (Fri, 22 Mar 2024) $

// SIO4: Fast Async Protocol Library: Utilities: source file

#include "main.h"



//*****************************************************************************
int fasync_show_util(
	int						fd,
	int						index,
	int						verbose,
	sio4_fasync_t*			fasync,
	FILE*					file,
	sio4_fasync_error_t*	error)
{
	int	errs;
	int	ret;

	if (verbose)
	{
		gsc_label_index("Fast Async Show", index);
		printf("...\n");
	}

	ret		= sio4_fasync_show(fd, fasync, file, error);
	errs	= (ret < 0) ? 1 : 0;

	if (verbose == 0)
	{
	}
	else if (errs)
	{
		gsc_label_index("Fast Async Show", index);
		printf("FAIL <---  (sio4_fasync_show(): ret = %d)\n", ret);
	}
	else
	{
		gsc_label_index("Fast Async Show", index);
		printf("PASS\n");
	}

	return(errs);
}


