// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/fasync/utils/wait_cancel_util.c $
// $Rev: 54330 $
// $Date: 2024-03-22 11:04:01 -0500 (Fri, 22 Mar 2024) $

// SIO4: Fast Async Protocol Library: Utilities: source file

#include "main.h"



//*****************************************************************************
int fasync_wait_cancel_util(
	int						fd,
	int						index,
	int						verbose,
	gsc_wait_t*				wait,
	sio4_fasync_error_t*	error)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Fast Async Wait Cancel", index);

	if (wait)
	{
		ret		= sio4_fasync_wait_cancel(fd, wait, error);
		errs	= ret ? 1 : 0;

		if (verbose)
		{
			printf(	"%s  (%ld wait%s cancelled)\n",
					errs ? "FAIL <---" : "PASS",
					(long) wait->count,
					(wait->count == 1) ? "" : "s");
		}
	}
	else
	{
		errs	= 1;

		if (verbose)
			printf(	"FAIL <---  (NULL pointer)\n");
	}

	return(errs);
}


