// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/fasync/utils/write_util.c $
// $Rev: 54330 $
// $Date: 2024-03-22 11:04:01 -0500 (Fri, 22 Mar 2024) $

// SIO4: Fast Async Protocol Library: Utilities: source file

#include "main.h"



//*****************************************************************************
int fasync_write_util(
	int						fd,
	int						index,
	int						verbose,
	const void*				src,
	size_t					bytes,
	size_t*					sent,
	sio4_fasync_error_t*	error)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("Fast Async Write", index);

	ret		= sio4_fasync_write(fd, src, bytes, error);
	errs	= (ret < 0) ? 1 : 0;

	if (verbose == 0)
	{
	}
	else if (ret >= 0)
	{
		printf("PASS  (%d Byte%s)\n", ret, (ret == 1) ? "" : "s");
	}
	else
	{
		printf(	"FAIL <---  (requested %ld Byte%s, ret = %ld)\n",
				(long) bytes,
				(bytes == 1) ? "" : "s",
				(long) ret);
	}

	if (sent)
		sent[0]	= (ret >= 0) ? ret : 0;

	return(errs);
}


