// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/hdlc/api/rx_adrs.c $
// $Rev: 50131 $
// $Date: 2022-02-04 09:04:14 -0600 (Fri, 04 Feb 2022) $

// SIO4: HDLC Protocol Library: source file

#include "main.h"



//*****************************************************************************
static int _show(s32 set, FILE* file)
{
	char	buf[64];
	int		errs	= 0;

	hdlc_show_label(file, "USC Rx Address");

	if (set == -1)
	{
		hdlc_show_fprintf(file, "This service is not supported by this device.\n");
	}
	else if ((set < 0) || (set > 0xFF))
	{
		errs++;
		hdlc_show_fprintf(file, "Invalid value: %ld\n", (long) set);
	}
	else
	{
		gsc_label_long_comma_buf(set, buf);
		hdlc_show_fprintf(file, "%s\n", buf);
	}

	return(errs);
}



//*****************************************************************************
void sio4_hdlc_t_rx_adrs(
	int					fd,
	s32*				arg,
	sio4_hdlc_action_t	action,
	FILE*				file,
	const char**		err)
{
	#define		ERROR	  "hdlc->rx.adrs"
	int			errs	= 0;
	const char*	sts		= NULL;
	u32			tmp;

	switch (action)
	{
		default:

				sts		= ERROR;
				break;

		case SIO4_HDLC_ACTION_GET:

				errs	= sio4_reg_read(fd, -1, 0, SIO4_USC_RSR, &tmp);
				arg[0]	= (s32) (tmp & 0xFF);
				break;

		case SIO4_HDLC_ACTION_INIT:

				arg[0] = 0xFF;
				break;

		case SIO4_HDLC_ACTION_SET:

				errs	= sio4_reg_mod(fd, -1, 0, SIO4_USC_RSR, arg[0], 0xFF);
				break;

		case SIO4_HDLC_ACTION_SHOW:

				errs	= _show(arg[0], file);
				break;

		case SIO4_HDLC_ACTION_VERIFY:

				if ((arg[0] < -1) || (arg[0] > 0xFF))
					errs	= 1;

				break;
	}

	if (errs)
		sts		= ERROR;

	if ((err) && (sts))
		err[0]	= sts;
}


