// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/hdlc/api/tx_abort.c $
// $Rev: 52181 $
// $Date: 2022-12-13 12:22:03 -0600 (Tue, 13 Dec 2022) $

// SIO4: HDLC Protocol Library: source file

#include "main.h"



//*****************************************************************************
static int _perform_operation(hdlc_device_t* dev)
{
	s32		arg;
	int		ret;

	// Send the abort request.
	arg	= SIO4_USC_TX_CMD_SEND_ABORT;
	ret	= sio4_ioctl(dev->fd, SIO4_IOCTL_USC_TX_CMD, &arg);
	return(ret);
}



/******************************************************************************
*
*	Function:	sio4_hdlc_tx_abort
*
*	Purpose:
*
*		Flush the tx side of the device and software.
*
*	Arguments:
*
*		fd		The file descriptor for the SIO4 channel to access.
*
*	Returned:
*
*		0		All went well.
*		-errno	There was a problem.
*
******************************************************************************/

int sio4_hdlc_tx_abort(int fd)
{
	hdlc_device_t*	dev	= NULL;
	int				ret;

	for (;;)	// A convenience loop.
	{
		// Verify Initialization ==========================
		ret	= hdlc_lib_init_verify(NULL);

		if (ret)
			break;

		// Access Device ==================================
		ret	= hdlc_lib_fd_inc(fd, &dev);

		if (ret)
			break;

		// Perform Operation ==============================

		if (dev->z16c30)
			ret	= _perform_operation(dev);
		else
			ret	= -EPROTONOSUPPORT;

		// Release Device =================================
		hdlc_lib_fd_dec(dev);
		break;
	}

	return(ret);
}


