// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/hdlc/api/tx_preamble_length.c $
// $Rev: 50131 $
// $Date: 2022-02-04 09:04:14 -0600 (Fri, 04 Feb 2022) $

// SIO4: HDLC Protocol Library: source file

#include "main.h"



//*****************************************************************************
static int _show(s32 set, FILE* file)
{
	char		buf[128];
	int			errs	= 0;
	const char*	ptr;

	hdlc_show_label(file, "USC Tx Preamble Length");

	switch (set)
	{
		default:

			errs++;
			ptr	= buf;
			sprintf(buf, "Unrecognized option: 0x%lX", (long) set);
			break;

		case -1:

			ptr	= "This service is not supported by this device.";
			break;

		case SIO4_HDLC_TX_PREAMBLE_LENGTH_8_BITS:

			ptr	= "8-bits";
			break;

		case SIO4_HDLC_TX_PREAMBLE_LENGTH_16_BITS:

			ptr	= "16-bits";
			break;

		case SIO4_HDLC_TX_PREAMBLE_LENGTH_32_BITS:

			ptr	= "32-bits";
			break;

		case SIO4_HDLC_TX_PREAMBLE_LENGTH_64_BITS:

			ptr	= "64-bits";
			break;
	}

	hdlc_show_fprintf(file, "%s\n", ptr);
	return(errs);
}



//*****************************************************************************
void sio4_hdlc_t_tx_preamble_length(
	int					fd,
	s32*				arg,
	sio4_hdlc_action_t	action,
	FILE*				file,
	const char**		err)
{
	#define		ERROR	  "hdlc->tx.preamble.length"
	int			errs	= 0;
	const char*	sts		= NULL;
	s32			tmp;

	switch (action)
	{
		default:

				sts		= ERROR;
				break;

		case SIO4_HDLC_ACTION_GET:

				arg[0]	= -1;
				errs	= sio4_usc_tx_preamble_len(fd, -1, 0, arg[0], arg);
				break;

		case SIO4_HDLC_ACTION_INIT:

				arg[0]	= SIO4_HDLC_TX_PREAMBLE_LENGTH_8_BITS;
				break;

		case SIO4_HDLC_ACTION_SET:

				tmp		= arg[0];
				errs	= sio4_usc_tx_preamble_len(fd, -1, 0, tmp, NULL);
				break;

		case SIO4_HDLC_ACTION_SHOW:

				errs	= _show(arg[0], file);
				break;

		case SIO4_HDLC_ACTION_VERIFY:

				switch (arg[0])
				{
					default:				errs	= 1;		break;
					case -1:
					case SIO4_HDLC_TX_PREAMBLE_LENGTH_8_BITS:
					case SIO4_HDLC_TX_PREAMBLE_LENGTH_16_BITS:
					case SIO4_HDLC_TX_PREAMBLE_LENGTH_32_BITS:
					case SIO4_HDLC_TX_PREAMBLE_LENGTH_64_BITS:	break;
				}

				break;
	}

	if (errs)
		sts		= ERROR;

	if ((err) && (sts))
		err[0]	= sts;
}


