// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/hdlc/utils/hdlc_open_util.c $
// $Rev: 53122 $
// $Date: 2023-06-16 15:04:11 -0500 (Fri, 16 Jun 2023) $

// SIO4: HDLC Protocol Library: Utilities: source file

#include "main.h"



//*****************************************************************************
int hdlc_open_util(int device, int share, int index, int verbose, int* fd)
{
	const char*	access	= share ? "Share" : "Exclusive";
	int			board	= device / 4;
	int			chan	= device % 4;
	int			errs;
	int			ret;

	if (verbose)
		gsc_label_index("HDLC Open", index);

	ret		= sio4_hdlc_open(device, share, fd);
	errs	= (ret < 0) ? 1 : 0;

	if (verbose)
	{
		if (errs)
			printf("FAIL <---  (ret = %d, ", ret);
		else
			printf("PASS  (");

		printf("%s, board %d, channel %d)\n", access, board, chan);
	}

	return(errs);
}


