// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/include/sio4_fasync_utils.h $
// $Rev: 54277 $
// $Date: 2024-03-19 10:19:35 -0500 (Tue, 19 Mar 2024) $

// SIO4: Fast Async Protocol Library: Utilities: header file

#ifndef	__SIO4_FASYNC_UTILS_H__
#define	__SIO4_FASYNC_UTILS_H__

#include "sio4_fasync.h"
#include "gsc_utils.h"



// prototypes *****************************************************************

// Fast Async Protocol Library utility services

int	fasync_close_util			(int fd, int index, int verbose, sio4_fasync_error_t* error);
int	fasync_get_util				(int fd, int index, int verbose, sio4_fasync_t* fasync, sio4_fasync_error_t* error);
int	fasync_gpio_rx_util			(int fd, int index, int verbose, u32* get, sio4_fasync_error_t* error);
int	fasync_gpio_tx_util			(int fd, int index, int verbose, u32 set, sio4_fasync_error_t* error);
int	fasync_init_api_util		(int verbose, sio4_fasync_error_t* error);
int	fasync_init_data_util		(int fd, int index, int verbose, const sio4_fasync_init_t* init, sio4_fasync_t* fasync, sio4_fasync_error_t* error);
int	fasync_ioctl_util			(int fd, int index, int verbose, int request, void* arg, sio4_fasync_error_t* error);
int	fasync_open_util			(int device, int share, int index, int verbose, int* fd, sio4_fasync_error_t* error);
int	fasync_read_util			(int fd, int index, int verbose, void* dst, size_t bytes, size_t* got, sio4_fasync_error_t* error);
int	fasync_reset_util			(int fd, int index, int verbose, sio4_fasync_error_t* error);
int	fasync_rx_fifo_reset_util	(int fd, int index, int verbose, sio4_fasync_error_t* error);
int	fasync_rx_io_abort_util		(int fd, int index, int verbose, s32* get, sio4_fasync_error_t* error);
int	fasync_set_util				(int fd, int index, int verbose, sio4_fasync_t* fasync, sio4_fasync_error_t* error);
int	fasync_show_util			(int fd, int index, int verbose, sio4_fasync_t* fasync, FILE* file, sio4_fasync_error_t* error);
int	fasync_tx_fifo_reset_util	(int fd, int index, int verbose, sio4_fasync_error_t* error);
int	fasync_tx_io_abort_util		(int fd, int index, int verbose, s32* get, sio4_fasync_error_t* error);
int	fasync_verify_util			(int fd, int index, int verbose, const sio4_fasync_t* fasync, sio4_fasync_error_t* error);
int	fasync_wait_cancel_util		(int fd, int index, int verbose, gsc_wait_t* wait, sio4_fasync_error_t* error);
int	fasync_wait_event_util		(int fd, int index, int verbose, gsc_wait_t* wait, sio4_fasync_error_t* error);
int	fasync_wait_status_util		(int fd, int index, int verbose, gsc_wait_t* wait, sio4_fasync_error_t* error);
int	fasync_write_util			(int fd, int index, int verbose, const void* src, size_t bytes, size_t* sent, sio4_fasync_error_t* error);



#endif
