// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/isoc/api/cable_legacy_rxd_dcd.c $
// $Rev: 43633 $
// $Date: 2018-10-15 15:54:18 -0500 (Mon, 15 Oct 2018) $

// SIO4: Isochronous Protocol Library: source file

#include "main.h"



//*****************************************************************************
static int _show(s32 set)
{
	char		buf[128];
	int			errs	= 0;
	const char*	ptr;

	gsc_label("Cable RxD/DCD (Legacy)");

	switch (set)
	{
		default:

			errs++;
			ptr	= buf;
			sprintf(buf, "Unrecognized option: 0x%lX", (long) set);
			break;

		case -1:

			ptr	= "This service is inactive or upsupported.";
			break;

		case SIO4_ISOC_CABLE_LEGACY_RXD_DCD_DISABLE:

			ptr	= "Disable";
			break;

		case SIO4_ISOC_CABLE_LEGACY_RXD_DCD_UP:

			ptr	= "Upper";
			break;

		case SIO4_ISOC_CABLE_LEGACY_RXD_DCD_LOW:

			ptr	= "Lower";
			break;
	}

	printf("%s\n", ptr);
	return(errs);
}



//*****************************************************************************
void sio4_isoc_t_cable_legacy_rxd_dcd(
	int					fd,
	s32*				arg,
	sio4_isoc_action_t	action,
	const char**		err)
{
	#define		ERROR	  "isoc->cable.legacy.rxd_dcd"
	int			errs	= 0;
	const char*	sts		= NULL;
	s32			tmp;

	switch (action)
	{
		default:

				sts		= ERROR;
				break;

		case SIO4_ISOC_ACTION_GET:

				arg[0]	= -1;
				errs	= sio4_z16_leg_rxd_dcd_cfg(fd, -1, 0, arg[0], arg);
				break;

		case SIO4_ISOC_ACTION_INIT:

				arg[0]	= SIO4_ISOC_CABLE_LEGACY_RXD_DCD_LOW;
				break;

		case SIO4_ISOC_ACTION_SET:

				tmp		= arg[0];
				errs	= sio4_z16_leg_rxd_dcd_cfg(fd, -1, 0, tmp, NULL);
				break;

		case SIO4_ISOC_ACTION_SHOW:

				errs	= _show(arg[0]);
				break;

		case SIO4_ISOC_ACTION_VERIFY:

				switch (arg[0])
				{
					default:						errs	= 1;	break;
					case -1:
					case SIO4_ISOC_CABLE_LEGACY_RXD_DCD_DISABLE:
					case SIO4_ISOC_CABLE_LEGACY_RXD_DCD_UP:
					case SIO4_ISOC_CABLE_LEGACY_RXD_DCD_LOW:		break;
				}

				break;
	}

	if (errs)
		sts		= ERROR;

	if ((err) && (sts))
		err[0]	= sts;
}


