// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/isoc/api/close.c $
// $Rev: 43633 $
// $Date: 2018-10-15 15:54:18 -0500 (Mon, 15 Oct 2018) $

// SIO4: Isochronous Protocol Library: source file

#include "main.h"



/******************************************************************************
*
*	Function:	sio4_isoc_close
*
*	Purpose:
*
*		Close a channel that has been opened to an SIO4 channel for Isochronous
*		use.
*
*	Arguments:
*
*		fd		The file descriptor for the SIO4 channel to close.
*
*	Returned:
*
*		0		All went well.
*		-errno	There was a problem.
*
******************************************************************************/

int sio4_isoc_close(int fd)
{
	isoc_device_t*	dev;
	int				ret;

	for (;;)	// A convenience loop.
	{
		// Make sure the library is initialized.

		if (isoc_initialized == 0)
		{
			ret	= -EPROTO;
			break;
		}

		// Gain access to the device.
		dev	= isoc_lib_fd_find_inc(fd);

		if (dev == NULL)
		{
			ret	= -ENODEV;
			break;
		}

		// Begin closing access.
		ret	= isoc_lib_dev_dec_release(dev);

		if (ret)
			break;

		isoc_rx_close(dev);
		isoc_tx_close(dev);
		sio4_close(fd);
		os_sem_destroy(&dev->sem);
		memset(dev, 0, sizeof(dev[0]));
		free(dev);
		break;
	}

	return(ret);
}



