// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/isoc/api/init.c $
// $Rev: 43636 $
// $Date: 2018-10-15 15:59:22 -0500 (Mon, 15 Oct 2018) $

// SIO4: Isochronous Protocol Library: source file

#include "main.h"



// variables ******************************************************************

		int				isoc_initialized		= 0;

static	isoc_device_t*	_list[32];
static	os_sem_t		_sem;



//*****************************************************************************
isoc_device_t* isoc_lib_dev_alloc_inc(void)
{
	isoc_device_t*	dev		= NULL;
	int				i;
	int				ret;

	for (;;)	// A convenience loop.
	{
		if (isoc_initialized == 0)
			break;

		ret	= os_sem_lock(&_sem);

		if (ret)
			break;

		for (i = 0; i < (int) SIZEOF_ARRAY(_list); i++)
		{
			if (_list[i] == NULL)
			{
				dev	= malloc(sizeof(isoc_device_t));

				if (dev)
				{
					memset(dev, 0, sizeof(isoc_device_t));
					dev->users++;
					_list[i]	= dev;
					break;
				}
			}
		}

		os_sem_unlock(&_sem);
		break;
	}

	return(dev);
}



//*****************************************************************************
int isoc_lib_dev_dec(isoc_device_t* dev)
{
	int	ret;

	for (;;)	// A convenience loop.
	{
		if (isoc_initialized == 0)
		{
			ret	= -EPROTO;
			break;
		}

		ret	= os_sem_lock(&_sem);

		if (ret)
			break;

		if (dev->users > 0)
			dev->users--;

		os_sem_unlock(&_sem);
		break;
	}

	return(ret);
}



//*****************************************************************************
int isoc_lib_dev_dec_release(isoc_device_t* dev)
{
	int	i;
	int	ret;

	for (;;)	// A convenience loop.
	{
		if (isoc_initialized == 0)
		{
			ret	= -EPROTO;
			break;
		}

		ret	= os_sem_lock(&_sem);

		if (ret)
			break;

		if (dev->users > 1)
		{
			os_sem_unlock(&_sem);
			ret	= -EBUSY;
			break;
		}

		for (i = 0; i < (int) SIZEOF_ARRAY(_list); i++)
		{
			if (_list[i] == dev)
			{
				_list[i]	= NULL;
				break;
			}
		}

		os_sem_unlock(&_sem);
		break;
	}

	return(ret);
}



//*****************************************************************************
isoc_device_t* isoc_lib_fd_find_inc(int fd)
{
	isoc_device_t*	dev	= NULL;
	int				i;
	int				ret;

	for (;;)	// A convenience loop.
	{
		if (isoc_initialized == 0)
			break;

		ret	= os_sem_lock(&_sem);

		if (ret)
			break;

		for (i = 0; i < (int) SIZEOF_ARRAY(_list); i++)
		{
			if (_list[i] == NULL)
				continue;

			if (_list[i]->fd == fd)
			{
				dev	= _list[i];
				break;
			}
		}

		os_sem_unlock(&_sem);
		break;
	}

	return(dev);
}



//*****************************************************************************
int sio4_isoc_init(void)
{
	int	ret	= 0;

	if (isoc_initialized == 0)
	{
		ret	= sio4_init();

		if (ret == 0)
			ret	= os_sem_create(&_sem);

		if (ret == 0)
			isoc_initialized	= 1;
	}

	return(ret);
}


