// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/isoc/api/ioctl.c $
// $Rev: 53119 $
// $Date: 2023-06-16 15:01:19 -0500 (Fri, 16 Jun 2023) $

// SIO4: Isochronous Protocol Library: source file

#include "main.h"



/******************************************************************************
*
*	Function:	sio4_isoc_ioctl
*
*	Purpose:
*
*		Issue an IOCTL request for an SIO4 channel opened for Isochronous use.
*
*	Arguments:
*
*		fd		The file descriptor for the SIO4 channel to access.
*
*		request	The IOCTL service to issue.
*
*		arg		The argument associated with the IOCTL service being requested.
*
*	Returned:
*
*		0		All went well.
*		-errno	There was a problem.
*
******************************************************************************/

int sio4_isoc_ioctl(int fd, int request, void* arg)
{
	int	ret;

	// Make sure the library is initialized.

	if (isoc_initialized == 0)
	{
		ret	= -EPROTO;
	}
	else
	{
		// Perform the requested operation.
		ret	= sio4_ioctl(fd, request, arg);
	}

	return(ret);
}



