// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/isoc/api/main.h $
// $Rev: 50140 $
// $Date: 2022-02-07 07:02:19 -0600 (Mon, 07 Feb 2022) $

// SIO4: Isochronous Protocol Library: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <errno.h>
#include <stdio.h>
#include <stdlib.h>

#include "sio4_dsl.h"
#include "sio4_utils.h"
#include "sio4_isoc.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)		(sizeof((a))/sizeof((a)[0]))

#undef	ERROR



// data types *****************************************************************

typedef struct
{
	os_sem_t		sem;
	int				fd;
	int				users;

	struct
	{
		os_sem_t	sem;	// Read requests are serialized.
	} rx;

	struct
	{
		os_sem_t	sem;	// Write requests are serialized.
	} tx;

} isoc_device_t;



// variables ******************************************************************

extern	int	isoc_initialized;



// prototypes *****************************************************************

isoc_device_t*	isoc_lib_dev_alloc_inc(void);					// returns NULL or valid pointer
int				isoc_lib_dev_dec(isoc_device_t* dev);			// returns 0 or -errno
int				isoc_lib_dev_dec_release(isoc_device_t* dev);	// returns 0 or -errno
isoc_device_t*	isoc_lib_fd_find_inc(int fd);					// returns NULL for error

void			isoc_rx_close(isoc_device_t* dev);
int				isoc_rx_open(isoc_device_t* dev);				// returns 0 or -errno

const char*		sio4_isoc_t_access(isoc_device_t* dev, sio4_isoc_t* isoc, sio4_isoc_action_t action);	// returns NULL or error

void			isoc_tx_close(isoc_device_t* dev);
int				isoc_tx_open(isoc_device_t* dev);				// returns 0 or -errno



#endif
