// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/isoc/api/rx_char_len.c $
// $Rev: 49774 $
// $Date: 2021-12-10 14:23:44 -0600 (Fri, 10 Dec 2021) $

// SIO4: Isochronous Protocol Library: source file

#include "main.h"



//*****************************************************************************
static int _show(s32 set)
{
	char		buf[128];
	int			errs	= 0;
	const char*	ptr;

	gsc_label("USC Rx Char Length");

	switch (set)
	{
		default:

			errs++;
			ptr	= buf;
			sprintf(buf, "Unrecognized option: 0x%lX", (long) set);
			break;

		case -1:

			ptr	= "This service is not supported by this device.";
			break;

		case SIO4_ISOC_RX_CHAR_LEN_1:

			ptr	= "1-bit";
			break;

		case SIO4_ISOC_RX_CHAR_LEN_2:

			ptr	= "2-bits";
			break;

		case SIO4_ISOC_RX_CHAR_LEN_3:

			ptr	= "3-bits";
			break;

		case SIO4_ISOC_RX_CHAR_LEN_4:

			ptr	= "4-bits";
			break;

		case SIO4_ISOC_RX_CHAR_LEN_5:

			ptr	= "5-bits";
			break;

		case SIO4_ISOC_RX_CHAR_LEN_6:

			ptr	= "6-bits";
			break;

		case SIO4_ISOC_RX_CHAR_LEN_7:

			ptr	= "7-bits";
			break;

		case SIO4_ISOC_RX_CHAR_LEN_8:

			ptr	= "8-bits";
			break;
	}

	printf("%s\n", ptr);
	return(errs);
}



//*****************************************************************************
void sio4_isoc_t_rx_char_len(
	int					fd,
	s32*				arg,
	sio4_isoc_action_t	action,
	const char**		err)
{
	#define		ERROR	  "isoc->rx.char_len"
	int			errs	= 0;
	const char*	sts		= NULL;
	s32			tmp;

	switch (action)
	{
		default:

				sts		= ERROR;
				break;

		case SIO4_ISOC_ACTION_GET:

				arg[0]	= -1;
				errs	= sio4_usc_rx_char_len(fd, -1, 0, arg[0], arg);
				break;

		case SIO4_ISOC_ACTION_INIT:

				arg[0]	= SIO4_ISOC_RX_CHAR_LEN_8;
				break;

		case SIO4_ISOC_ACTION_SET:

				tmp		= arg[0];
				errs	= sio4_usc_rx_char_len(fd, -1, 0, tmp, NULL);
				break;

		case SIO4_ISOC_ACTION_SHOW:

				errs	= _show(arg[0]);
				break;

		case SIO4_ISOC_ACTION_VERIFY:

				switch (arg[0])
				{
					default:		errs	= 1;	break;
					case -1:
					case SIO4_ISOC_RX_CHAR_LEN_1:
					case SIO4_ISOC_RX_CHAR_LEN_2:
					case SIO4_ISOC_RX_CHAR_LEN_3:
					case SIO4_ISOC_RX_CHAR_LEN_4:
					case SIO4_ISOC_RX_CHAR_LEN_5:
					case SIO4_ISOC_RX_CHAR_LEN_6:
					case SIO4_ISOC_RX_CHAR_LEN_7:
					case SIO4_ISOC_RX_CHAR_LEN_8:	break;
				}

				break;
	}

	if (errs)
		sts		= ERROR;

	if ((err) && (sts))
		err[0]	= sts;
}


