// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/isoc/api/rx_fifo_size.c $
// $Rev: 49774 $
// $Date: 2021-12-10 14:23:44 -0600 (Fri, 10 Dec 2021) $

// SIO4: Isochronous Protocol Library: source file

#include "main.h"



//*****************************************************************************
static int _show(s32 set)
{
	int	errs	= 0;

	gsc_label("Rx FIFO Size");

	if (set == -1)
	{
		printf("This service is not supported by this device.\n");
	}
	else if ((set < 0) || (set > 0xFFFF))
	{
		errs++;
		printf("Invalid value: %ld\n", (long) set);
	}
	else if (set % 1024)
	{
		gsc_label_long_comma(set);
		printf(" Byte%s\n", (set == 1) ? "" : "s");
	}
	else
	{
		gsc_label_long_comma(set / 1024);
		printf("K Bytes\n");
	}

	return(errs);
}



//*****************************************************************************
void sio4_isoc_t_rx_fifo_size(
	int					fd,
	s32*				arg,
	sio4_isoc_action_t	action,
	const char**		err)
{
	#define		ERROR	  "isoc->rx.fifo.size"
	int			errs	= 0;
	const char*	sts		= NULL;

	switch (action)
	{
		default:

				sts		= ERROR;
				break;

		case SIO4_ISOC_ACTION_GET:
		case SIO4_ISOC_ACTION_INIT:

				arg[0]	= SIO4_QUERY_FIFO_SIZE_RX;
				errs	= sio4_isoc_ioctl(fd, SIO4_IOCTL_QUERY, arg);
				break;

		case SIO4_ISOC_ACTION_SET:

				// We do nothing here.
				break;

		case SIO4_ISOC_ACTION_SHOW:

				errs	= _show(arg[0]);
				break;

		case SIO4_ISOC_ACTION_VERIFY:

				if (arg[0] < -1)
					errs	= 1;

				break;
	}

	if (errs)
		sts		= ERROR;

	if ((err) && (sts))
		err[0]	= sts;
}


