// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/isoc/api/tx.c $
// $Rev: 43633 $
// $Date: 2018-10-15 15:54:18 -0500 (Mon, 15 Oct 2018) $

// SIO4: Isochronous Protocol Library: source file

#include "main.h"



/******************************************************************************
*
*	Function:	isoc_tx_open
*
*	Purpose:
*
*		Initialize Tx use of a channel being opened.
*
*	Arguments:
*
*		dev		The structure for the channel being accessed.
*
*	Returned:
*
*		0		All went well.
*		-errno	There was a problem.
*
******************************************************************************/

int isoc_tx_open(isoc_device_t* dev)
{
	int	ret;

	if (dev)
	{
		memset(&dev->tx, 0, sizeof(dev->tx));
		ret	= os_sem_create(&dev->tx.sem);
	}
	else
	{
		ret	= -EINVAL;
	}

	return(ret);
}



/******************************************************************************
*
*	Function:	isoc_tx_close
*
*	Purpose:
*
*		Cleanup Tx use of a channel being closed.
*
*	Arguments:
*
*		dev		The structure for the channel being accessed.
*
*	Returned:
*
*		None.
*
******************************************************************************/

void isoc_tx_close(isoc_device_t* dev)
{
	if (dev)
	{
		os_sem_destroy(&dev->tx.sem);
		memset(&dev->tx, 0, sizeof(dev->tx));
	}
}


