// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/isoc/api/tx_bit_rate.c $
// $Rev: 49774 $
// $Date: 2021-12-10 14:23:44 -0600 (Fri, 10 Dec 2021) $

// SIO4: Isochronous Protocol Library: source file

#include "main.h"



//*****************************************************************************
static int _show(s32 set)
{
	int	errs	= 0;

	gsc_label("Tx Bit Rate");

	if (set == -1)
	{
		printf("This service is not supported by this device.\n");
	}
	else if (set < 0)
	{
		errs++;
		printf("Invalid value: %ld\n", (long) set);
	}
	else if (set == 0)
	{
		printf("Not recorded for later retrieval (0).\n");
	}
	else
	{
		gsc_label_long_comma(set);
		printf(" b/S\n");
	}

	return(errs);
}



//*****************************************************************************
void sio4_isoc_t_tx_bit_rate(
	s32*				arg,
	sio4_isoc_action_t	action,
	const char**		err)
{
	#define		ERROR	  "isoc->tx.bit_rate"
	int			errs	= 0;
	const char*	sts		= NULL;

	switch (action)
	{
		default:

				sts		= ERROR;
				break;

		case SIO4_ISOC_ACTION_GET:

				// Not recorded for later retrieval.
				arg[0]	= 0;
				break;

		case SIO4_ISOC_ACTION_INIT:

				// Not recorded for later retrieval.
				arg[0]	= 0;
				break;

		case SIO4_ISOC_ACTION_SET:

				// We do nothing here.
				break;

		case SIO4_ISOC_ACTION_SHOW:

				errs	= _show(arg[0]);
				break;

		case SIO4_ISOC_ACTION_VERIFY:

				if ((arg[0] < -1) || (arg[0] > 20000000))
					errs	= 1;

				break;
	}

	if (errs)
		sts		= ERROR;

	if ((err) && (sts))
		err[0]	= sts;
}


