// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/samples/id/main.h $
// $Rev: 53146 $
// $Date: 2023-06-16 15:21:16 -0500 (Fri, 16 Jun 2023) $

// SIO4: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "sio4_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	detail;
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of devices detected.
	s32	test_limit;		// for continuous testing

	int	fd[4];			// File descriptor for devices to access.

	// Device Settings

} args_t;



// prototypes *****************************************************************

int		channels_close(const args_t* args);
int		channels_open(const args_t* args, int* fd);
void	column_headings(const args_t* args);

void	local_label_str(const char* str);

int		perform_tests(const args_t* args);

int		query_list(const args_t* args);
int		query_read_chans(const args_t* args, int sorted, int option, s32* val);

int		regs_fr_detail(const args_t* args);
int		regs_frr_detail(const args_t* args);
int		regs_list_fw(const args_t* args);
int		regs_list_id_gsc(const args_t* args);
int		regs_list_id_plx(const args_t* args);
int		regs_list_id_usc(const args_t* args);
int		regs_list_usc(const args_t* args);

int		validate_same_s32(const args_t* args, s32* val);
int		validate_same_u32(const args_t* args, u32* val);



#endif
