// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/samples/irq/main.h $
// $Rev: 54311 $
// $Date: 2024-03-19 10:44:57 -0500 (Tue, 19 Mar 2024) $

// SIO4: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "sio4_main.h"



// macros *********************************************************************

#define	D8						(1 << 8)
#define	D9						(1 << 9)

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))

#define	STATUS_NOT_IMPLEMENTED	(-2)
#define	STATUS_NOT_SUPPORTED	(-1)
#define	STATUS_SUPPORTED		(0)



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of devices detected.
	s32	test_limit;		// for continuous testing

	int	fd;				// File descriptor for device to access.

	// Device Settings

} args_t;



// variables ******************************************************************

extern	const args_t*	cargs;



// prototypes *****************************************************************

int	main_dma_irq_test(int fd, int supported);
int	main_gsc_irq_test(int fd, int supported);
int	main_pci_irq_test(int fd, int supported);

int	perform_tests(const args_t* args);

int	rx_envelope_test(int fd, int supported);
int	rx_fifo_almost_full_test(int fd, int supported);
int	rx_fifo_empty_test(int fd, int supported);
int	rx_fifo_full_test(int fd, int supported);
int	rx_frame_error_test(int fd, int supported);
int	rx_parity_error_test(int fd, int supported);
int	rx_spare_test(int fd, int supported);

int	sync_detected_test(int fd, int supported);

int	tx_fifo_almost_empty_test(int fd, int supported);
int	tx_fifo_empty_test(int fd, int supported);
int	tx_fifo_full_test(int fd, int supported);

int	usc_brg0_zero_test(int fd, int supported);
int	usc_brg1_zero_test(int fd, int supported);
int	usc_cts_down_test(int fd, int supported);
int	usc_cts_up_test(int fd, int supported);
int	usc_dcd_down_test(int fd, int supported);
int	usc_dcd_up_test(int fd, int supported);
int	usc_dpll_desync_test(int fd, int supported);
int	usc_rcc_underrun_test(int fd, int supported);
int	usc_rx_abort_pe_test(int fd, int supported);
int	usc_rx_bound_test(int fd, int supported);
int	usc_rx_break_abort_test(int fd, int supported);
int	usc_rx_data_test(int fd, int supported);
int	usc_rx_exited_hunt_test(int fd, int supported);
int	usc_rx_idle_received_test(int fd, int supported);
int	usc_rx_overrun_test(int fd, int supported);
int	usc_rxc_down_test(int fd, int supported);
int	usc_rxc_up_test(int fd, int supported);
int	usc_rxreq_down_test(int fd, int supported);
int	usc_rxreq_up_test(int fd, int supported);
int	usc_test(int fd, int supported);
int	usc_tx_abort_sent_test(int fd, int supported);
int	usc_tx_crc_sent_test(int fd, int supported);
int	usc_tx_data_test(int fd, int supported);
int	usc_tx_eof_eom_sent_test(int fd, int supported);
int	usc_tx_idle_sent_test(int fd, int supported);
int	usc_tx_preamble_sent_test(int fd, int supported);
int	usc_tx_underrun_test(int fd, int supported);
int	usc_txc_down_test(int fd, int supported);
int	usc_txc_up_test(int fd, int supported);
int	usc_txreq_down_test(int fd, int supported);
int	usc_txreq_up_test(int fd, int supported);



#endif
