// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/samples/irq/rx_frame_error.c $
// $Rev: 54334 $
// $Date: 2024-03-22 11:15:18 -0500 (Fri, 22 Mar 2024) $

// SIO4: Sample Application: source file

#include "main.h"




//*****************************************************************************
static int _irq_check_support(int fd)
{
	int	errs	= 0;
	s32	fw;
	int	ret;

	errs	+= sio4_query(fd, -1, 0, SIO4_QUERY_FW_TYPE, &fw);

	if (errs)
	{
		ret	= errs;
	}
	else if (fw == SIO4_FW_TYPE_Z16C30)
	{
		ret	= STATUS_NOT_SUPPORTED;
	}
	else if (fw == SIO4_FW_TYPE_SYNC)
	{
		ret	= STATUS_NOT_SUPPORTED;
	}
	else if (fw == SIO4_FW_TYPE_FASYNC)
	{
		ret	= STATUS_NOT_IMPLEMENTED;
	}
	else
	{
		ret	= STATUS_NOT_SUPPORTED;
	}

	return(ret);
}



//*****************************************************************************
static int _irq_initiate(int fd)
{
	int	errs	= 1;

	// We should never get here as we can't generate the interrupt.
	return(errs);
}



//*****************************************************************************
int rx_frame_error_test(int fd, int supported)
{
	int	ret;

	if (supported)
		ret	= _irq_check_support(fd);
	else
		ret	= _irq_initiate(fd);

	return(ret);
}


