// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/samples/irq/usc_cts_down.c $
// $Rev: 43027 $
// $Date: 2018-06-22 17:39:16 -0500 (Fri, 22 Jun 2018) $

// SIO4: Sample Application: source file

#include "main.h"




//*****************************************************************************
static int _irq_check_support(int fd)
{
	int	errs;
	int	ret;
	s32	z16c30;

	errs	= sio4_query(fd, -1, 0, SIO4_QUERY_MODEL_Z16C30, &z16c30);

	if (errs)
		ret	= errs;
	else if (z16c30)
		ret	= STATUS_SUPPORTED;
	else
		ret	= STATUS_NOT_SUPPORTED;

	return(ret);
}



//*****************************************************************************
static int _irq_initiate(int fd)
{
	int		errs	= 0;

	// Generate a USC interrupt: I/O Pin CTS Fall
	errs	+= sio4_initialize		(fd, -1, 0, 1,							NULL);

	errs	+= sio4_usc_cts_cfg		(fd, -1, 0, SIO4_USC_CTS_CFG_OUT_0,		NULL);
	errs	+= sio4_irq_usc_enable	(fd, -1, 0, SIO4_IRQ_USC_IOP_CTS_FALL,	NULL);

	errs	+= sio4_usc_cts_cfg		(fd, -1, 0, SIO4_USC_CTS_CFG_TRI,		NULL);
	errs	+= sio4_reg_mod			(fd, -1, 0, SIO4_USC_IOCR, 0x0000, 0xC000);
	os_sleep_ms(1);

	errs	+= sio4_usc_cts_cfg		(fd, -1, 0, SIO4_USC_CTS_CFG_OUT_0,		NULL);
	errs	+= sio4_reg_mod			(fd, -1, 0, SIO4_USC_IOCR, 0x8000, 0xC000);
	os_sleep_ms(1);

	errs	+= sio4_usc_cts_cfg		(fd, -1, 0, SIO4_USC_CTS_CFG_OUT_1,		NULL);
	errs	+= sio4_reg_mod			(fd, -1, 0, SIO4_USC_IOCR, 0xC000, 0xC000);
	os_sleep_ms(1);

	errs	+= sio4_usc_cts_cfg		(fd, -1, 0, SIO4_USC_CTS_CFG_OUT_0,		NULL);
	errs	+= sio4_reg_mod			(fd, -1, 0, SIO4_USC_IOCR, 0x8000, 0xC000);
	os_sleep_ms(1);

	errs	+= sio4_initialize		(fd, -1, 0, 1,							NULL);
	return(errs);
}



//*****************************************************************************
int usc_cts_down_test(int fd, int supported)
{
	int	ret;

	if (supported)
		ret	= _irq_check_support(fd);
	else
		ret	= _irq_initiate(fd);

	return(ret);
}


