// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/samples/irq/usc_txc_down.c $
// $Rev: 43027 $
// $Date: 2018-06-22 17:39:16 -0500 (Fri, 22 Jun 2018) $

// SIO4: Sample Application: source file

#include "main.h"




//*****************************************************************************
static int _irq_check_support(int fd)
{
	int	errs;
	int	ret;
	s32	z16c30;

	errs	= sio4_query(fd, -1, 0, SIO4_QUERY_MODEL_Z16C30, &z16c30);

	if (errs)
		ret	= errs;
	else if (z16c30)
		ret	= STATUS_SUPPORTED;
	else
		ret	= STATUS_NOT_SUPPORTED;

	return(ret);
}



//*****************************************************************************
static int _irq_initiate(int fd)
{
	int		errs	= 0;

	// Generate a USC interrupt: I/O Pin TxC Fall
	errs	+= sio4_initialize		(fd, -1, 0, 1,								NULL);
	errs	+= sio4_osc_program		(fd, -1, 0, 20000000,						NULL);

	errs	+= sio4_usc_txc_cfg		(fd, -1, 0, SIO4_USC_TXC_CFG_IN_OSC,		NULL);

	errs	+= sio4_irq_usc_enable	(fd, -1, 0, SIO4_IRQ_USC_IOP_TXC_FALL,		NULL);

	os_sleep_ms(50);
	return(errs);
}



//*****************************************************************************
int usc_txc_down_test(int fd, int supported)
{
	int	ret;

	if (supported)
		ret	= _irq_check_support(fd);
	else
		ret	= _irq_initiate(fd);

	return(ret);
}


