// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/sync/api/read.c $
// $Rev: 49568 $
// $Date: 2021-07-27 12:17:19 -0500 (Tue, 27 Jul 2021) $

// SIO4: SYNC Protocol Library: source file

#include "main.h"



/******************************************************************************
*
*	Function:	sio4_sync_read
*
*	Purpose:
*
*		Read in a block of data.
*
*	Arguments:
*
*		fd		The file descriptor for the SIO4 channel to access.
*
*		dst		The data read goes here.
*
*		bytes	Read no more than this number of bytes.
*
*	Returned:
*
*		>= 0	The number of bytes read.
*		-errno	There was a problem.
*
******************************************************************************/

int sio4_sync_read(int fd, void* dst, size_t bytes)
{
	int	ret;

	if (sync_initialized == 0)
	{
		ret	= -EPROTO;
	}
	else
	{
		ret	= sio4_read(fd, dst, bytes);
	}

	return(ret);
}


