// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/sync/api/write.c $
// $Rev: 54265 $
// $Date: 2024-03-19 10:05:07 -0500 (Tue, 19 Mar 2024) $

// SIO4: SYNC Protocol Library: source file

#include "main.h"



/******************************************************************************
*
*	Function:	sio4_sync_write
*
*	Purpose:
*
*		Send out a block of data.
*
*	Arguments:
*
*		fd		The file descriptor for the SIO4 channel to access.
*
*		src		The source for the data to write.
*
*		bytes	The number of bytes to write.
*
*	Returned:
*
*		>= 0	The number of bytes written.
*		-errno	There was a problem.
*
******************************************************************************/

int sio4_sync_write(int fd, const void* src, size_t bytes)
{
	int	ret;

	if (sync_initialized == 0)
	{
		ret	= -EPROTO;
	}
	else
	{
		ret	= sio4_write(fd, src, bytes);
	}

	return(ret);
}


