// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/sync/samples/gpio/main.h $
// $Rev: 53141 $
// $Date: 2023-06-16 15:18:12 -0500 (Fri, 16 Jun 2023) $

// SIO4: SYNC Protocol Library: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "sio4_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))

#define	D0						(0x1 << 0)
#define	D1						(0x1 << 1)
#define	D2						(0x1 << 2)
#define	D3						(0x1 << 3)
#define	D4						(0x1 << 4)
#define	D5						(0x1 << 5)
#define	D6						(0x1 << 6)
#define	D7						(0x1 << 7)
#define	D8						(0x1 << 8)
#define	D9						(0x1 << 9)



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of devices detected.
	s32	seconds;
	int	skip;			// Skip testing due to wrong firmware type?
	s32	test_limit;		// for continuous testing

	int	fd;				// File descriptor for device to access.

	// Device Settings

	s32	xcvr;
} args_t;



// prototypes *****************************************************************

int	cable_test(const args_t* args, int* legacy);

int	perform_tests(const args_t* args, int* skip);
int	pstsr_support_test(const args_t* args, int bit, const char* name, int* supported);

int	rxauxc_test	(const args_t* args, int legacy);
int	rxc_test	(const args_t* args, int legacy);
int	rxd_test	(const args_t* args, int legacy);
int	rxe_test	(const args_t* args, int legacy);
int	rxspare_test(const args_t* args, int legacy);

int	txauxc_test	(const args_t* args, int legacy);
int	txc_test	(const args_t* args, int legacy);
int	txd_test	(const args_t* args, int legacy);
int	txe_test	(const args_t* args, int legacy);
int	txspare_test(const args_t* args, int legacy);

int	xcvr_test	(const args_t* args);

int	toggle_bit_test(
		const args_t*	args,
		int				(*gpio_enable)	(const args_t* args),
		int				(*gpio_disable)	(const args_t* args),
		int				(*gpio_out)		(const args_t* args, int level),
		int				(*gpio_in)		(const args_t* args, int* level));



#endif
