// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/sync/samples/gpio/perform.c $
// $Rev: 54282 $
// $Date: 2024-03-19 10:28:34 -0500 (Tue, 19 Mar 2024) $

// SIO4: SYNC Protocol Library: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _verify_model(const args_t* args, int* skip)
{
	int	errs;
	s32	sync;

	errs	= sio4_query(args->fd, -1, 1, SIO4_QUERY_MODEL_SYNC, &sync);

	if (errs)
	{
		skip[0]	= 1;
	}
	else if (sync)
	{
		skip[0]	= 0;
	}
	else
	{
		skip[0]	= 1;
		gsc_label(NULL);
		printf("SKIP  (Not a SYNC model SIO4.)\n");
	}

	return(errs);
}



//*****************************************************************************
int perform_tests(const args_t* args, int* skip)
{
	int	cable_legacy	= 0;
	int	errs;

	for (;;)	// A convenience loop.
	{
		errs	= _verify_model(args, skip);

		if ((errs) || (skip[0]))
			break;

		errs	+= xcvr_test(args);
		errs	+= cable_test(args, &cable_legacy);

		if (errs)
		{
			printf("ABORTING TEST DUE TO ERRORS\n");
			break;
		}

		errs	+= txc_test		(args, cable_legacy);
		errs	+= txd_test		(args, cable_legacy);
		errs	+= txe_test		(args, cable_legacy);
		errs	+= txauxc_test	(args, cable_legacy);
		errs	+= txspare_test	(args, cable_legacy);
		errs	+= rxc_test		(args, cable_legacy);
		errs	+= rxd_test		(args, cable_legacy);
		errs	+= rxe_test		(args, cable_legacy);
		errs	+= rxauxc_test	(args, cable_legacy);
		errs	+= rxspare_test	(args, cable_legacy);
		break;
	}

	return(errs);
}


