// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/sync/samples/gpio/txe.c $
// $Rev: 50028 $
// $Date: 2022-01-20 13:03:39 -0600 (Thu, 20 Jan 2022) $

// SIO4: SYNC Protocol Library: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _gpio_enable(const args_t* args)
{
	int	errs;
	s32	val;

	val		= SIO4_SYNC_TXE_CFG_OUT_0;
	errs	= sync_ioctl_util(args->fd, -1, 0, SIO4_IOCTL_SYNC_TXE_CFG, &val);
	return(errs);
}



//*****************************************************************************
static int _gpio_disable(const args_t* args)
{
	int	errs;
	s32	val;

	val		= SIO4_SYNC_TXE_CFG_ACTIVE_HI;
	errs	= sync_ioctl_util(args->fd, -1, 0, SIO4_IOCTL_SYNC_TXE_CFG, &val);
	return(errs);
}



//*****************************************************************************
static int _gpio_out(const args_t* args, int level)
{
	int	errs;
	s32	val;

	if (level)
		val	= SIO4_SYNC_TXE_CFG_OUT_1;
	else
		val	= SIO4_SYNC_TXE_CFG_OUT_0;

	errs	= sync_ioctl_util(args->fd, -1, 0, SIO4_IOCTL_SYNC_TXE_CFG, &val);
	return(errs);
}



//*****************************************************************************
static int _gpio_in(const args_t* args, int* level)
{
	int			errs;
	gsc_reg_t	reg;

	reg.reg		= SIO4_GSC_PSTSR;
	reg.value	= 0xDEADBEEF;
	reg.mask	= 0;
	errs		= sync_ioctl_util(args->fd, -1, 0, SIO4_IOCTL_REG_READ, &reg);

	if (reg.value & D6)	// D6 = TxE Output State
		level[0]	= 1;
	else
		level[0]	= 0;

	return(errs);
}



//*****************************************************************************
int txe_test(const args_t* args, int legacy)
{
	int	errs;
	int	supported;

	gsc_label("TxE (Output)");
	errs	= pstsr_support_test(args, D6, "TxE", &supported);

	if ((errs) || (supported == 0))
	{
	}
	else if (legacy)
	{
		printf("SKIPPED	(Legacy operation not implemented.)\n");
	}
	else
	{
		errs	= toggle_bit_test(
					args,
					_gpio_enable,
					_gpio_disable,
					_gpio_out,
					_gpio_in);
	}

	return(errs);
}


