// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/sync/utils/sync_write_util.c $
// $Rev: 53124 $
// $Date: 2023-06-16 15:05:26 -0500 (Fri, 16 Jun 2023) $

// SIO4: SYNC Protocol Library: Utilities: source file

#include "main.h"



//*****************************************************************************
int sync_write_util(int fd, int index, int verbose, const void* src, size_t bytes, size_t* sent)
{
	int	errs;
	int	ret;

	if (verbose)
		gsc_label_index("SYNC Writing", index);

	ret		= sio4_sync_write(fd, src, bytes);
	errs	= (ret < 0) ? 1 : 0;

	if (verbose == 0)
	{
	}
	else if (ret >= 0)
	{
		printf("PASS  (%d Byte%s)\n", ret, (ret == 1) ? "" : "s");
	}
	else
	{
		printf(	"FAIL <---  (requested %ld Byte%s, ret = %ld)\n",
				(long) bytes,
				(bytes == 1) ? "" : "s",
				(long) ret);
	}

	if (sent)
		sent[0]	= (ret >= 0) ? ret : 0;

	return(errs);
}


