// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/utils/sio4_utils_main.h $
// $Rev: 50146 $
// $Date: 2022-02-07 07:05:30 -0600 (Mon, 07 Feb 2022) $

// SIO4: Utilities: header file

#ifndef	__SIO4_UTILS_MAIN_H__
#define	__SIO4_UTILS_MAIN_H__

#include "sio4_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)		(sizeof((a))/sizeof((a)[0]))

#define	_GSC_REG(a)			"GSC " #a, SIO4_GSC_##a, 0, 0
#define	_USC_REG(a)			"USC " #a, SIO4_USC_##a, 0, 0
#define	_USC_CY22393(a)		"CY22393 " #a, a, 0, 0
#define	WIDTH				22

#define	FIELD_DECODE		GSC_FIELD_DECODE

#define	FIELD_SHOW(beg,end,eol,lst,dsc)		\
			gsc_reg_field_show(width+10,WIDTH,value,(beg),(end),(eol),(lst),(dsc))

#define	QUERY_BOARD_RESET(fd, ptr)	sio4_query((fd), SIO4_QUERY_BOARD_RESET, (ptr))
#define	QUERY_FORM_FACTOR(fd,ptr)	sio4_query((fd), SIO4_QUERY_FORM_FACTOR, (ptr))
#define	QUERY_FW_TYPE(fd,ptr)		sio4_query((fd), SIO4_QUERY_FW_TYPE, (ptr))
#define	QUERY_LED_MAIN(fd,ptr)		sio4_query((fd), SIO4_QUERY_LED_MAIN, (ptr))
#define	QUERY_MODEL_BASE(fd,ptr)	sio4_query((fd), SIO4_QUERY_MODEL_BASE, (ptr))
#define	QUERY_OSC_CHIP(fd, ptr)		sio4_query((fd), SIO4_QUERY_OSC_CHIP, (ptr))
#define	QUERY_REG_BSR(fd, ptr)		sio4_query((fd), SIO4_QUERY_REG_BSR, (ptr))
#define	QUERY_REG_CCR(fd, ptr)		sio4_query((fd), SIO4_QUERY_REG_CCR, (ptr))
#define	QUERY_REG_FCR(fd, ptr)		sio4_query((fd), SIO4_QUERY_REG_FCR, (ptr))
#define	QUERY_REG_FR(fd, ptr)		sio4_query((fd), SIO4_QUERY_REG_FR, (ptr))
#define	QUERY_REG_FSR(fd, ptr)		sio4_query((fd), SIO4_QUERY_REG_FSR, (ptr))
#define	QUERY_REG_FTR(fd, ptr)		sio4_query((fd), SIO4_QUERY_REG_FTR, (ptr))
#define	QUERY_REG_GPIOSR(fd, ptr)	sio4_query((fd), SIO4_QUERY_REG_GPIOSR, (ptr))
#define	QUERY_REG_IELR(fd, ptr)		sio4_query((fd), SIO4_QUERY_REG_IELR, (ptr))
#define	QUERY_REG_IHLR(fd, ptr)		sio4_query((fd), SIO4_QUERY_REG_IHLR, (ptr))
#define	QUERY_REG_IOCR(fd, ptr)		sio4_query((fd), SIO4_QUERY_REG_IOCR, (ptr))
#define	QUERY_REG_PSRCR(fd, ptr)	sio4_query((fd), SIO4_QUERY_REG_PSRCR, (ptr))
#define	QUERY_REG_PSTSR(fd, ptr)	sio4_query((fd), SIO4_QUERY_REG_PSTSR, (ptr))
#define	QUERY_REG_RCR(fd, ptr)		sio4_query((fd), SIO4_QUERY_REG_RCR, (ptr))
#define	QUERY_REG_SBR(fd, ptr)		sio4_query((fd), SIO4_QUERY_REG_SBR, (ptr))
#define	QUERY_REG_TCR(fd, ptr)		sio4_query((fd), SIO4_QUERY_REG_TCR, (ptr))
#define	QUERY_REG_TSR(fd, ptr)		sio4_query((fd), SIO4_QUERY_REG_TSR, (ptr))
#define	QUERY_SIO4_MODEL(fd,ptr)	sio4_query((fd), SIO4_QUERY_MODEL_BASE, (ptr))
#define	QUERY_SIO4_TYPE(fd,ptr)		sio4_query((fd), SIO4_QUERY_SIO4_TYPE, (ptr))
#define	QUERY_LEGACY_MODE(fd,ptr)	sio4_query((fd), SIO4_QUERY_LEGACY_CABLE, (ptr))



// prototypes *****************************************************************

int	sio4_reg_sio4_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4_irq(int fd, int supported, u32 value, int width, const char** state);

int	sio4_reg_sio4a_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4a_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4a_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4a_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4a_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4a_psrcr(int fd, int supported, u32 value, int width);

int	sio4_reg_sio4a_sync_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4a_sync_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4a_sync_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4a_sync_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4a_sync_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4a_sync_irq(int fd, u32 value, int width, const char** state);

int	sio4_reg_sio4ahrm_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ahrm_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ahrm_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ahrm_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ahrm_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ahrm_psrcr(int fd, int supported, u32 value, int width);

int	sio4_reg_sio4ahrm_sync_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ahrm_sync_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ahrm_sync_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ahrm_sync_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ahrm_sync_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ahrm_sync_irq(int fd, u32 value, int width, const char** state);

int	sio4_reg_sio4ar_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ar_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ar_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ar_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ar_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ar_psrcr(int fd, int supported, u32 value, int width);

int	sio4_reg_sio4ar_sync_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ar_sync_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ar_sync_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ar_sync_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ar_sync_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4ar_sync_irq(int fd, u32 value, int width, const char** state);

int	sio4_reg_sio4b_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4b_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4b_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4b_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4b_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4b_psrcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4b_pstsr(int fd, int supported, u32 value, int width);

int	sio4_reg_sio4b_sync_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4b_sync_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4b_sync_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4b_sync_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4b_sync_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4b_sync_irq(int fd, u32 value, int width, const char** state);
int	sio4_reg_sio4b_sync_psrcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4b_sync_pstsr(int fd, int supported, u32 value, int width);

int	sio4_reg_sio4bx_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx_psrcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx_pstsr(int fd, int supported, u32 value, int width);

int	sio4_reg_sio4bx_sync_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx_sync_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx_sync_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx_sync_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx_sync_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx_sync_psrcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx_sync_pstsr(int fd, int supported, u32 value, int width);

int	sio4_reg_sio4bx2_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx2_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx2_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx2_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx2_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx2_psrcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx2_pstsr(int fd, int supported, u32 value, int width);

int	sio4_reg_sio4bx2_sync_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx2_sync_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx2_sync_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx2_sync_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx2_sync_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx2_sync_psrcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bx2_sync_pstsr(int fd, int supported, u32 value, int width);

int	sio4_reg_sio4bxr_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bxr_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bxr_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bxr_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bxr_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bxr_psrcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bxr_pstsr(int fd, int supported, u32 value, int width);

int	sio4_reg_sio4bxr_sync_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bxr_sync_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bxr_sync_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bxr_sync_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bxr_sync_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bxr_sync_psrcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio4bxr_sync_pstsr(int fd, int supported, u32 value, int width);

int	sio4_reg_sio8bx2_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bx2_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bx2_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bx2_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bx2_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bx2_psrcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bx2_pstsr(int fd, int supported, u32 value, int width);

int	sio4_reg_sio8bx2_sync_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bx2_sync_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bx2_sync_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bx2_sync_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bx2_sync_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bx2_sync_psrcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bx2_sync_pstsr(int fd, int supported, u32 value, int width);

int	sio4_reg_sio8bxs_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bxs_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bxs_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bxs_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bxs_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bxs_psrcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bxs_pstsr(int fd, int supported, u32 value, int width);

int	sio4_reg_sio8bxs_sync_bcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bxs_sync_bsr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bxs_sync_csr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bxs_sync_fr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bxs_sync_frr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bxs_sync_psrcr(int fd, int supported, u32 value, int width);
int	sio4_reg_sio8bxs_sync_pstsr(int fd, int supported, u32 value, int width);



#endif
