// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/utils/util_cbl_pin_status.c $
// $Rev: 49784 $
// $Date: 2021-12-10 14:59:38 -0600 (Fri, 10 Dec 2021) $

// SIO4: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	sio4_cbl_pin_status
*
*	Purpose:
*
*		Provide a visual wrapper for the SIO4_IOCTL_CBL_PIN_STATUS service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		This is the value to apply.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int sio4_cbl_pin_status(int fd, int index, int verbose, s32 set, s32* get)
{
	char	buf[128];
	int		errs;
	int		ret;

	if (verbose)
		gsc_label_index("Cable Pin Status", index);

	ret		= sio4_ioctl(fd, SIO4_IOCTL_CBL_PIN_STATUS, &set);
	errs	= ret ? 1 : 0;


	if (set == -1)
		sprintf(buf, "  (This service is not supported by this device.)");
	else
		sprintf(buf, "  (0x%lX)", (long) set);

	if (verbose)
		printf("%s%s\n", errs ? "FAIL <---" : "PASS", buf);

	if (get)
		get[0]	= set;

	return(errs);
}


