// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/utils/util_reg_read_raw.c $
// $Rev: 42860 $
// $Date: 2018-05-18 11:53:07 -0500 (Fri, 18 May 2018) $

// SIO4: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	sio4_reg_read_raw
*
*	Purpose:
*
*		Provide a visual wrapper for the SIO4_IOCTL_REG_READ_RAW service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		reg		The zero based index of the 32-bit register to access.
*
*		get		The results are reported here. This may be NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int sio4_reg_read_raw(int fd, int index, int verbose, u32 reg, u32* get)
{
	gsc_reg_t	arg;
	int			errs;
	int			ret;

	if (verbose)
		gsc_label_index("Reg. Read Raw", index);

	arg.reg		= reg;
	arg.value	= 0xDEADBEEF;
	arg.mask	= 0;	// unused here
	ret			= sio4_ioctl(fd, SIO4_IOCTL_REG_READ_RAW, &arg);
	errs		= ret ? 1 : 0;


	if (verbose)
	{
		printf(	"%s  (val 0x%08lX, reg %u)\n",
				errs ? "FAIL <---" : "PASS",
				(unsigned long) arg.value,
				(unsigned int) reg);
	}

	if (get)
		get[0]	= arg.value;

	return(errs);
}


