// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/utils/util_reg_sio4ar_sync.c $
// $Rev: 54264 $
// $Date: 2024-03-19 10:04:01 -0500 (Tue, 19 Mar 2024) $

// SIO4: Utilities: source file

#include "main.h"



//*****************************************************************************
int sio4_reg_sio4ar_sync_bcr(int fd, int supported, u32 value, int width)
{
	static const char*	_dmdma[]	=
	{
		"Channel 1 Rx FIFO",
		"Channel 3 Rx FIFO",
		"Channel 2 Rx FIFO",
		"Channel 4 Rx FIFO",
		"Channel 1 Tx FIFO",
		"Channel 3 Tx FIFO",
		"Channel 2 Tx FIFO",
		"Channel 4 Tx FIFO"
	};

	static const char*	_idle[]	= { "Idle",	"Active"	};

	int	ret;

	if (supported)
	{
		ret	= 1;
	}
	else
	{
		//

		FIELD_SHOW	(31, 31, 1, _idle,	"Board Reset"	);
		FIELD_SHOW	(30,  7, 1, NULL,	"Reserved"		);
		FIELD_SHOW	( 6,  4, 1, _dmdma,	"DMDMA 1"		);
		FIELD_SHOW	( 3,  3, 1, NULL,	"NULL"			);
		FIELD_SHOW	( 2,  0, 1, _dmdma,	"DMDMA 0"		);

		ret	= 0;
	}

	return(ret);
}



//*****************************************************************************
int sio4_reg_sio4ar_sync_bsr(int fd, int supported, u32 value, int width)
{
	static const char*	_0_on[]	= { "Jumper On",	"Jumper Off"	};

	int	ret;

	if (supported)
	{
		ret	= 1;
	}
	else
	{
		//

		FIELD_SHOW	(31,  2, 1, NULL,	"Reserved"		);
		FIELD_SHOW	( 1,  1, 1, _0_on,	"Board ID 2"	);
		FIELD_SHOW	( 0,  0, 1, _0_on,	"Board ID 1"	);

		ret	= 0;
	}

	return(ret);
}



//*****************************************************************************
int sio4_reg_sio4ar_sync_csr(int fd, int supported, u32 value, int width)
{
	static const char*	_disable[]	= { "Disabled",		"Enabled"		};
	static const char*	_dual[]		= { "Normal",		"Dual"			};
	static const char*	_fall[]		= { "Falling Edge",	"Rising Edge"	};
	static const char*	_hi[]		= { "High",			"Low"			};
	static const char*	_idle[]		= { "Idle",			"Active"		};
	static const char*	_int[]		= { "No",			"Internal"		};
	static const char*	_l_rxd[]	= { "Disable",		"Lower RxD"		};
	static const char*	_l_txd[]	= { "Disable",		"Lower TxD"		};
	static const char*	_msb[]		= { "MSB",			"LSB"			};
	static const char*	_no[]		= { "No",			"Yes"			};
	static const char*	_remain[]	= { "No Change",	"Disable"		};
	static const char*	_txclksrc[]	= { "Internal",		"External"		};
	static const char*	_u_rxd[]	= { "Disable",		"Upper RxD"		};
	static const char*	_u_txd[]	= { "Disable",		"Upper TxD"		};
	static const char*	_yes[]		= { "Yes",			"No"			};

	int	ret;

	if (supported)
	{
		ret	= 1;
	}
	else
	{
		//

		FIELD_SHOW(31, 31, 1, _no,			"Rx Count Err"			);
		FIELD_SHOW(30, 30, 1, NULL,			"Reserved"				);
		FIELD_SHOW(29, 29, 1, _dual,		"Sync Mode"				);
		FIELD_SHOW(28, 28, 1, _int,			"Int Loopback"			);
		FIELD_SHOW(27, 27, 1, _hi,			"Tx Env Pol"			);
		FIELD_SHOW(26, 26, 1, _hi,			"Rx Env Pol"			);
		FIELD_SHOW(25, 25, 1, _msb,			"Tx First Bit"			);
		FIELD_SHOW(24, 24, 1, _msb,			"Rx First Bit"			);
		FIELD_SHOW(23, 23, 1, _idle,		"Rx Count Clr"			);
		FIELD_SHOW(22, 22, 1, _txclksrc,	"Tx Clk Source"			);
		FIELD_SHOW(21, 21, 1, _idle,		"Tx Clk Idle"			);
		FIELD_SHOW(20, 20, 1, _fall,		"Tx Clk Pol"			);
		FIELD_SHOW(19, 19, 1, _fall,		"Rx Clk Pol"			);
		FIELD_SHOW(18, 18, 1, _remain,		"Tx FIFO Full Config"	);
		FIELD_SHOW(17, 17, 1, _disable,		"Tx Enable"				);
		FIELD_SHOW(16, 16, 1, _disable,		"Rx Enable"				);
		FIELD_SHOW(15, 15, 1, _yes,			"Rx FIFO Full"			);
		FIELD_SHOW(14, 14, 1, _yes,			"Rx FIFO A Full"		);
		FIELD_SHOW(13, 13, 1, _yes,			"Rx FIFO A Empty"		);
		FIELD_SHOW(12, 12, 1, _yes,			"Rx FIFO Empty"			);
		FIELD_SHOW(11, 11, 1, _yes,			"Tx FIFO Full"			);
		FIELD_SHOW(10, 10, 1, _yes,			"Tx FIFO A Full"		);
		FIELD_SHOW( 9,  9, 1, _yes,			"Tx FIFO A Empty"		);
		FIELD_SHOW( 8,  8, 1, _yes,			"Tx FIFO Empty"			);
		FIELD_SHOW( 7,  6, 1, NULL,			"Reserved"				);
		FIELD_SHOW( 5,  5, 1, _u_rxd,		"RxDatUprEn"			);
		FIELD_SHOW( 4,  4, 1, _l_rxd,		"RxDatLwrEn"			);
		FIELD_SHOW( 3,  3, 1, _u_txd,		"TxDatUprEn"			);
		FIELD_SHOW( 2,  2, 1, _l_txd,		"TxDatLwrEn"			);
		FIELD_SHOW( 1,  1, 1, _idle,		"Rx FIFO Reset"			);
		FIELD_SHOW( 0,  0, 1, _idle,		"Tx FIFO Reset"			);

		ret	= 0;
	}

	return(ret);
}



//*****************************************************************************
int sio4_reg_sio4ar_sync_fr(int fd, int supported, u32 value, int width)
{
	static const char*	_osc[]	=
	{
		"Fixed Oscillator (20MHz default)",
		"ICD2053B (1x)",
		"ICD2053B (4x)",
		"CY22393 (1x)",
		"CY22393 (2x)",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED"
	};

	static const char*	_not[]	= { "No (Not Supported)",	"Yes (Present)"	};

	int	ret;

	if (supported)
	{
		ret	= 1;
	}
	else
	{
		//

		FIELD_SHOW(31,  5, 1, NULL,	"Reserved"				);
		FIELD_SHOW( 4,  4, 1, _not,	"FIFO Count/Size Regs"	);
		FIELD_SHOW( 3,  0, 1, _osc,	"Oscillator"			);

		ret	= 0;
	}

	return(ret);
}



//*****************************************************************************
int sio4_reg_sio4ar_sync_frr(int fd, int supported, u32 value, int width)
{
	static const char*	_form[]	=
	{
		"RESERVED",
		"PCI",
		"PMC",
		"cPCI",
		"PC/104+",
		"PCIe",
		"XMC",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED"
	};

	static const char*	_32bit[]	= { "32-bit",	"64-bit"	};
	static const char*	_33mhz[]	= { "33MHz",	"66MHz"		};
	static const char*	_no[]		= { "No",		"Yes"		};

	int	errs	= 0;
	u32	field;
	int	ret;

	if (supported)
	{
		ret	= 1;
	}
	else
	{
		//

		FIELD_SHOW	(31, 31, 1, _no,	"Features Reg"		);

		// Specification Compliance
		FIELD_SHOW	(30, 30, 0, NULL,	"Spec Compliant"	);

		if (value & 0x40000000)
		{
			printf("Yes\n");
		}
		else
		{
			errs++;
			printf("No  ERROR <---\n");
		}

		// Other fields
		FIELD_SHOW	(29, 29, 1, _33mhz,	"PCI Bus Speed"		);
		FIELD_SHOW	(28, 28, 1, _32bit,	"PCI Bus Width"		);
		FIELD_SHOW	(27, 24, 1, _form,	"Form Factor"		);
		FIELD_SHOW	(23, 20, 1, NULL,	"Board Type"		);

		// Hardware Revision
		FIELD_SHOW	(19, 16, 0, NULL,	"HW Rev"			);
		field	= FIELD_DECODE(value, 19, 16);

		if (field)
			printf("Rev %c\n", (char) ('A' + field - 1));
		else
			printf("NR\n");

		// Firmware Type
		FIELD_SHOW	(15,  8, 0, NULL,	"Firmware Type"		);
		field	= FIELD_DECODE(value, 15, 8);

		if (field == 0x04)
		{
			printf("SYNC\n");
		}
		else if (field == 0x01)
		{
			errs++;
			printf("Zilog  ERROR <---\n");
		}
		else if (field == 0x08)
		{
			errs++;
			printf("FASYNC  ERROR <---\n");
		}
		else
		{
			printf("Custom\n");
		}

		// Firmware Revision
		FIELD_SHOW	(7,  0, 0, NULL,	"Firmware Rev"		);
		field	= FIELD_DECODE(value, 7, 0);
		printf("%02lX\n", (long) field);

		ret	= errs;
	}

	return(ret);
}



//*****************************************************************************
int sio4_reg_sio4ar_sync_irq(int fd, u32 value, int width, const char** state)
{
	FIELD_SHOW(31, 31, 1, state,	"Ch4 Rx FIFO Full"	);
	FIELD_SHOW(30, 30, 1, state,	"Ch4 Rx FIFO Empty"	);
	FIELD_SHOW(29, 29, 1, state,	"Ch4 Tx FIFO Full"	);
	FIELD_SHOW(28, 28, 1, state,	"Ch4 Tx FIFO Empty"	);
	FIELD_SHOW(27, 27, 1, state,	"Ch3 Rx FIFO Full"	);
	FIELD_SHOW(26, 26, 1, state,	"Ch3 Rx FIFO Empty"	);
	FIELD_SHOW(25, 25, 1, state,	"Ch3 Tx FIFO Full"	);
	FIELD_SHOW(24, 24, 1, state,	"Ch3 Tx FIFO Empty"	);
	FIELD_SHOW(23, 23, 1, state,	"Ch2 Rx FIFO Full"	);
	FIELD_SHOW(22, 22, 1, state,	"Ch2 Rx FIFO Empty"	);
	FIELD_SHOW(21, 21, 1, state,	"Ch2 Tx FIFO Full"	);
	FIELD_SHOW(20, 20, 1, state,	"Ch2 Tx FIFO Empty"	);
	FIELD_SHOW(19, 19, 1, state,	"Ch1 Rx FIFO Full"	);
	FIELD_SHOW(18, 18, 1, state,	"Ch1 Rx FIFO Empty"	);
	FIELD_SHOW(17, 17, 1, state,	"Ch1 Tx FIFO Full"	);
	FIELD_SHOW(16, 16, 1, state,	"Ch1 Tx FIFO Empty"	);
	FIELD_SHOW(15, 15, 1, NULL,		"Reserved"			);
	FIELD_SHOW(14, 14, 1, state,	"Ch4 Rx FIFO AF"	);
	FIELD_SHOW(13, 13, 1, state,	"Ch4 Tx FIFO AE"	);
	FIELD_SHOW(12, 12, 1, NULL,		"Reserved"			);
	FIELD_SHOW(11, 11, 1, NULL,		"Reserved"			);
	FIELD_SHOW(10, 10, 1, state,	"Ch3 Rx FIFO AF"	);
	FIELD_SHOW( 9,  9, 1, state,	"Ch3 Tx FIFO AE"	);
	FIELD_SHOW( 8,  8, 1, NULL,		"Reserved"			);
	FIELD_SHOW( 7,  7, 1, NULL,		"Reserved"			);
	FIELD_SHOW( 6,  6, 1, state,	"Ch2 Rx FIFO AF"	);
	FIELD_SHOW( 5,  5, 1, state,	"Ch2 Tx FIFO AE"	);
	FIELD_SHOW( 4,  4, 1, NULL,		"Reserved"			);
	FIELD_SHOW( 3,  3, 1, NULL,		"Reserved"			);
	FIELD_SHOW( 2,  2, 1, state,	"Ch1 Rx FIFO AF"	);
	FIELD_SHOW( 1,  1, 1, state,	"Ch1 Tx FIFO AE"	);
	FIELD_SHOW( 0,  0, 1, NULL,		"Reserved"			);
	return(0);
}


