// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/SIO4%20and%20SIO8/SIO4_Linux_2.x.x_GSC_DN/utils/util_reg_sio8bx2v_fasync.c $
// $Rev: 54332 $
// $Date: 2024-03-22 11:12:14 -0500 (Fri, 22 Mar 2024) $

// SIO4: Utilities: source file

#include "main.h"



//*****************************************************************************
int sio4_reg_sio8bx2v_fasync_bcr(int fd, int supported, u32 value, int width)
{
	static const char*	_dmdma[]	=
	{
		"Channel 1 Rx FIFO",
		"Channel 3 Rx FIFO",
		"Channel 2 Rx FIFO",
		"Channel 4 Rx FIFO",
		"Channel 1 Tx FIFO",
		"Channel 3 Tx FIFO",
		"Channel 2 Tx FIFO",
		"Channel 4 Tx FIFO"
	};

	static const char*	_enable[]	= { "Enable",	"Disable"		};
	static const char*	_idle[]		= { "Idle",		"Active"		};
	static const char*	_led[]		= { "Off",		"On"			};

	int	ret	= 0;

	if (supported)
	{
		ret	= 1;
	}
	else
	{
		FIELD_SHOW	(31, 31, 1, _idle,		"Board Reset"	);
		FIELD_SHOW	(30, 27, 1, NULL,		"Reserved"		);
		FIELD_SHOW	(26, 26, 1, _led,		"Green LED D2"	);
		FIELD_SHOW	(25, 25, 1, _led,		"Green LED D3"	);
		FIELD_SHOW	(24, 24, 1, _led,		"Green LED D4"	);
		FIELD_SHOW	(23,  8, 1, NULL,		"Reserved"		);
		FIELD_SHOW	( 7,  7, 1, _enable,	"DMDMA 1 SCD"	);
		FIELD_SHOW	( 6,  4, 1, _dmdma,		"DMDMA 1"		);
		FIELD_SHOW	( 3,  3, 1, _enable,	"DMDMA 0 SCD"	);
		FIELD_SHOW	( 2,  0, 1, _dmdma,		"DMDMA 0"		);
	}

	return(ret);
}



//*****************************************************************************
int sio4_reg_sio8bx2v_fasync_bsr(int fd, int supported, u32 value, int width)
{
	static const char*	_1_on[]		= { "Jumper Off",	"Jumper On"			};

	int	ret	= 0;

	if (supported)
	{
		ret	= 1;
	}
	else
	{
		FIELD_SHOW	(31,  4, 1, NULL,	"Reserved"		);
		FIELD_SHOW	( 3,  3, 1, _1_on,	"Board ID 4"	);
		FIELD_SHOW	( 2,  2, 1, _1_on,	"Board ID 3"	);
		FIELD_SHOW	( 1,  1, 1, _1_on,	"Board ID 2"	);
		FIELD_SHOW	( 0,  0, 1, _1_on,	"Board ID 1"	);
	}

	return(ret);
}



//*****************************************************************************
int sio4_reg_sio8bx2v_fasync_csr(int fd, int supported, u32 value, int width)
{
	static const char*	_disable[]	= { "Disabled",		"Enabled"		};
	static const char*	_idle[]		= { "Idle",			"Active"		};
	static const char*	_no[]		= { "No",			"Yes"			};
	static const char*	_remain[]	= { "No Change",	"Disable"		};
	static const char*	_yes[]		= { "Yes",			"No"			};

	int	ret	= 0;

	if (supported)
	{
		ret	= 1;
	}
	else
	{
		FIELD_SHOW(31, 28, 1, NULL,			"Reserved"				);
		FIELD_SHOW(26, 26, 1, _remain,		"Tx FIFO Empty Config"	);
		FIELD_SHOW(25, 25, 1, _disable,		"Tx Enable"				);
		FIELD_SHOW(24, 24, 1, _disable,		"Rx Enable"				);
		FIELD_SHOW(23, 20, 1, NULL,			"LED Control"			);
		FIELD_SHOW(19, 19, 1, _no,			"Rx Stop on FIFO Full"	);
		FIELD_SHOW(18, 18, 1, _no,			"Rx FIFO Underflow"		);
		FIELD_SHOW(17, 17, 1, _no,			"Tx FIFO Overflow"		);
		FIELD_SHOW(16, 16, 1, _no,			"Rx FIFO Overflow"		);
		FIELD_SHOW(15, 15, 1, _yes,			"Rx FIFO Full"			);
		FIELD_SHOW(14, 14, 1, _yes,			"Rx FIFO A Full"		);
		FIELD_SHOW(13, 13, 1, _yes,			"Rx FIFO A Empty"		);
		FIELD_SHOW(12, 12, 1, _yes,			"Rx FIFO Empty"			);
		FIELD_SHOW(11, 11, 1, _yes,			"Tx FIFO Full"			);
		FIELD_SHOW(10, 10, 1, _yes,			"Tx FIFO A Full"		);
		FIELD_SHOW( 9,  9, 1, _yes,			"Tx FIFO A Empty"		);
		FIELD_SHOW( 8,  8, 1, _yes,			"Tx FIFO Empty"			);
		FIELD_SHOW( 7,  7, 1, NULL,			"Reserved"				);
		FIELD_SHOW( 6,  6, 1, _idle,		"Channel Reset"			);
		FIELD_SHOW( 5,  2, 1, NULL,			"Reserved"				);
		FIELD_SHOW( 1,  1, 1, _idle,		"Rx FIFO Reset"			);
		FIELD_SHOW( 0,  0, 1, _idle,		"Tx FIFO Reset"			);
	}

	return(ret);
}



//*****************************************************************************
int sio4_reg_sio8bx2v_fasync_fr(int fd, int supported, u32 value, int width)
{
	static const char*	_osc[]	=
	{
		"Fixed Oscillator (20MHz default)",
		"ICD2053B (1x)",
		"ICD2053B (4x)",
		"CY22393 (1x)",
		"CY22393 (2x)",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED"
	};

	static const char*	_fifo[]	=
	{
		"Not Configurable",
		"Tx/Rx Select",
		"RESERVED",
		"RESERVED"
	};

	static const char*	_fpga[]	=
	{
		"Not Present",
		"Present",
		"RESERVED",
		"RESERVED"
	};

	static const char*	_ts[]	=
	{
		"No Timestamp",
		"External Clock",
		"Internal Clock",
		"RESERVED"
	};

	static const char*	_no[]	= { "No",					"Yes"			};
	static const char*	_not[]	= { "No (Not Supported)",	"Yes (Present)"	};

	s32	field;
	int	ret		= 0;

	if (supported)
	{
		ret	= 1;
	}
	else
	{
		FIELD_SHOW(31, 25, 1, NULL,		"Reserved"				);
		FIELD_SHOW(24, 24, 1, _no,		"RxC Src/tx Pkt Xfer"	);
		FIELD_SHOW(23, 23, 1, _no,		"SYNC TStamp/Rx Wrd Sz"	);
		FIELD_SHOW(22, 22, 1, _no,		"Rx Stop @ Fill in CSR"	);
		FIELD_SHOW(21, 21, 1, _no,		"SRAM Debug"			);
		FIELD_SHOW(20, 20, 1, _no,		"Rx Status Byte"		);
		FIELD_SHOW(19, 18, 1, _ts,		"Timestamp"				);
		FIELD_SHOW(17, 16, 1, _fpga,	"FPGA Reprogram"		);
		FIELD_SHOW(15, 14, 1, _fifo,	"FIFO Space Config."	);
		FIELD_SHOW(13, 13, 1, _no,		"FIFO Test Bit"			);
		FIELD_SHOW(12, 12, 1, _no,		"Firmware Type Reg"		);
		FIELD_SHOW(11,  8, 1, NULL,		"Feature Level"			);
		FIELD_SHOW( 7,  7, 1, _not,		"DMDMA Single Cyc Dis"	);
		FIELD_SHOW( 6,  6, 1, _not,		"Board Reset"			);
		FIELD_SHOW( 5,  5, 1, _not,		"FIFO Count/Size Regs"	);

		FIELD_SHOW( 4,  4, 0, NULL,		"Spec Compliant"		);
		field	= FIELD_DECODE(value, 4, 4);

		if (field)
		{
			printf("Yes\n");
		}
		else
		{
			ret	= 1;
			printf("ERROR <---\n");
		}

		FIELD_SHOW( 3,  0, 1, _osc,		"Oscillator"			);
	}

	return(ret);
}



//*****************************************************************************
int sio4_reg_sio8bx2v_fasync_frr(int fd, int supported, u32 value, int width)
{
	static const char*	_board[]	=
	{
		"PCIe4-SIO8BX2/PCIe4-SIO8BX2V",
		"PCIe-SIO4BX",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED"
	};

	static const char*	_form[]	=
	{
		"RESERVED",
		"PCI",
		"PMC",
		"cPCI",
		"PC/104+",
		"PCIe",
		"XMC",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED",
		"RESERVED"
	};

	static const char*	_hwrev[]	=
	{
		"N/R",
		"A",
		"B",
		"C",
		"D",
		"E",
		"F",
		"G"
	};

	static const char*	_32bit[]	= { "32-bit",			"64-bit"			};
	static const char*	_33mhz[]	= { "33MHz",			"66MHz"				};
	static const char*	_b_rev[]	= { "PCIe4-SIO8BX2",	"PCIe4-SIO8BX2V"	};
	static const char*	_no[]		= { "No",				"Yes"				};

	int	errs	= 0;
	u32	field;
	int	ret;

	if (supported)
	{
		ret	= 1;
	}
	else
	{
		FIELD_SHOW	(31, 31, 1, _no,	"Features Reg"		);

		// Specification Compliance
		FIELD_SHOW	(30, 30, 0, NULL,	"Spec Compliant"	);

		if (value & 0x40000000)
		{
			printf("Yes\n");
		}
		else
		{
			errs++;
			printf("No  ERROR <---\n");
		}

		// Other fields
		FIELD_SHOW	(29, 29, 1, _33mhz,	"PCI Bus Speed"		);
		FIELD_SHOW	(28, 28, 1, _32bit,	"PCI Bus Width"		);
		FIELD_SHOW	(27, 24, 1, _form,	"Form Factor"		);
		FIELD_SHOW	(23, 20, 1, _board,	"Board Type"		);
		FIELD_SHOW	(19, 19, 1, _b_rev,	"Board Sub Rev"		);
		FIELD_SHOW	(18, 16, 1, _hwrev,	"HW Rev"			);

		// Firmware Type
		FIELD_SHOW	(15,  8, 0, NULL,	"Firmware Type"		);
		field	= FIELD_DECODE(value, 15, 8);

		if (field == 0x08)
		{
			printf("FASYNC\n");
		}
		else if (field == 0x04)
		{
			errs++;
			printf("SYNC  ERROR <---\n");
		}
		else if (field == 0x01)
		{
			errs++;
			printf("Zilog  ERROR <---\n");
		}
		else
		{
			errs++;
			printf("Custom  ERROR <---\n");
		}

		// Firmware Revision
		FIELD_SHOW	(7,  0, 0, NULL,	"Firmware Rev"		);
		field	= FIELD_DECODE(value, 7, 0);
		printf("%02lX\n", (long) field);

		ret	= errs;
	}

	return(ret);
}



//*****************************************************************************
static int _gsc_irq(u32 value, int width, const char* state[2])
{
	FIELD_SHOW(31, 31, 1, state,	"Ch4 Rx FIFO Full"	);
	FIELD_SHOW(30, 30, 1, state,	"Ch4 Rx FIFO Empty"	);
	FIELD_SHOW(29, 29, 1, state,	"Ch4 Tx FIFO Full"	);
	FIELD_SHOW(28, 28, 1, state,	"Ch4 Tx FIFO Empty"	);
	FIELD_SHOW(27, 27, 1, state,	"Ch3 Rx FIFO Full"	);
	FIELD_SHOW(26, 26, 1, state,	"Ch3 Rx FIFO Empty"	);
	FIELD_SHOW(25, 25, 1, state,	"Ch3 Tx FIFO Full"	);
	FIELD_SHOW(24, 24, 1, state,	"Ch3 Tx FIFO Empty"	);
	FIELD_SHOW(23, 23, 1, state,	"Ch2 Rx FIFO Full"	);
	FIELD_SHOW(22, 22, 1, state,	"Ch2 Rx FIFO Empty"	);
	FIELD_SHOW(21, 21, 1, state,	"Ch2 Tx FIFO Full"	);
	FIELD_SHOW(20, 20, 1, state,	"Ch2 Tx FIFO Empty"	);
	FIELD_SHOW(19, 19, 1, state,	"Ch1 Rx FIFO Full"	);
	FIELD_SHOW(18, 18, 1, state,	"Ch1 Rx FIFO Empty"	);
	FIELD_SHOW(17, 17, 1, state,	"Ch1 Tx FIFO Full"	);
	FIELD_SHOW(16, 16, 1, state,	"Ch1 Tx FIFO Empty"	);
	FIELD_SHOW(15, 15, 1, state,	"Ch4 Frame Error"	);
	FIELD_SHOW(14, 14, 1, state,	"Ch4 Rx FIFO AF"	);
	FIELD_SHOW(13, 13, 1, state,	"Ch4 Tx FIFO AE"	);
	FIELD_SHOW(12, 12, 1, state,	"Ch4 Parity Error"	);
	FIELD_SHOW(11, 11, 1, state,	"Ch3 Frame Error"	);
	FIELD_SHOW(10, 10, 1, state,	"Ch3 Rx FIFO AF"	);
	FIELD_SHOW( 9,  9, 1, state,	"Ch3 Tx FIFO AE"	);
	FIELD_SHOW( 8,  8, 1, state,	"Ch3 Parity Error"	);
	FIELD_SHOW( 7,  7, 1, state,	"Ch2 Frame Error"	);
	FIELD_SHOW( 6,  6, 1, state,	"Ch2 Rx FIFO AF"	);
	FIELD_SHOW( 5,  5, 1, state,	"Ch2 Tx FIFO AE"	);
	FIELD_SHOW( 4,  4, 1, state,	"Ch2 Parity Error"	);
	FIELD_SHOW( 3,  3, 1, state,	"Ch1 Frame Error"	);
	FIELD_SHOW( 2,  2, 1, state,	"Ch1 Rx FIFO AF"	);
	FIELD_SHOW( 1,  1, 1, state,	"Ch1 Tx FIFO AE"	);
	FIELD_SHOW( 0,  0, 1, state,	"Ch1 Parity Error"	);
	return(0);
}



//*****************************************************************************
int sio4_reg_sio8bx2v_fasync_icr(int fd, int supported, u32 value, int width)
{
	static const char*	_state[]	= { "Disabled",	"Enabled"	};

	int	errs;

	errs	= _gsc_irq(value, width, _state);
	return(errs);
}



//*****************************************************************************
int sio4_reg_sio8bx2v_fasync_isr(int fd, int supported, u32 value, int width)
{
	static const char*	_state[]	= { "Idle",	"Active"	};

	int	errs;

	errs	= _gsc_irq(value, width, _state);
	return(errs);
}



//*****************************************************************************
int sio4_reg_sio8bx2v_fasync_ielr(int fd, int supported, u32 value, int width)
{
	static const char*	_state[]	= { "Level",	"Edge"	};

	int	errs;

	errs	= _gsc_irq(value, width, _state);
	return(errs);
}



//*****************************************************************************
int sio4_reg_sio8bx2v_fasync_ihlr(int fd, int supported, u32 value, int width)
{
	static const char*	_state[]	= { "Low",	"High"	};

	int	errs;

	errs	= _gsc_irq(value, width, _state);
	return(errs);
}



//*****************************************************************************
int sio4_reg_sio8bx2v_fasync_psrcr(int fd, int supported, u32 value, int width)
{
	static const char*	_xcvr[]	=
	{
		"RS-422/RS-485",// 0
		"RESERVED",		// 1
		"RESERVED",		// 2
		"RESERVED",		// 3
		"RESERVED",		// 4
		"RESERVED",		// 5
		"RESERVED",		// 6
		"RESERVED",		// 7
		"RESERVED",		// 8
		"RESERVED",		// 9
		"RESERVED",		// 10
		"RESERVED",		// 11
		"RESERVED",		// 12
		"RESERVED",		// 13
		"RESERVED",		// 14
		"RESERVED",		// 15
	};

	static const char*	_gpio[]	=
	{
		"Disabled",	// 0
		"Input",	// 1
		"Output 0",	// 2
		"Output 1",	// 3
	};

	static const char*	_disable[]	= { "Disable",	"Enable"	};
	static const char*	_dte[]		= { "DTE",		"DCE"		};
	static const char*	_enable[]	= { "Enable",	"Disable"	};

	int	ret	= 0;

	if (supported)
	{
		ret	= 1;
	}
	else
	{
		FIELD_SHOW	(31, 31, 1, _disable,	"Cable Xcvr"			);
		FIELD_SHOW	(30, 30, 1, _enable,	"Term Resistors (Int)"	);
		FIELD_SHOW	(29, 29, 1, _disable,	"External Loopback"		);
		FIELD_SHOW	(28, 28, 1, _dte,		"DCE/DTE Mode"			);
		FIELD_SHOW	(27, 24, 1, _xcvr,		"Transceivers"			);
		FIELD_SHOW	(23, 23, 1, _disable,	"Internal Loopback"		);
		FIELD_SHOW	(22,  8, 1, NULL,		"Reserved"				);
		FIELD_SHOW	( 7,  6, 1, _gpio,		"GPIO D"				);
		FIELD_SHOW	( 5,  4, 1, _gpio,		"GPIO C"				);
		FIELD_SHOW	( 3,  2, 1, _gpio,		"GPIO B"				);
		FIELD_SHOW	( 1,  0, 1, _gpio,		"GPIO A"				);
	}

	return(ret);
}



//*****************************************************************************
int sio4_reg_sio8bx2v_fasync_pstsr(int fd, int supported, u32 value, int width)
{
	static const char*	_low[]	= { "0, Low",	"1, High"	};

	int	ret	= 0;

	if (supported)
	{
		ret	= 1;
	}
	else
	{
		FIELD_SHOW(31,  8, 1, NULL,	"Reserved"		);
		FIELD_SHOW( 7,  7, 1, _low,	"CTS DTE Input"	);
		FIELD_SHOW( 6,  6, 1, _low,	"CTS DCE Input"	);
		FIELD_SHOW( 5,  5, 1, _low,	"RXD DTE Input"	);
		FIELD_SHOW( 4,  4, 1, _low,	"RXD DCE Input"	);
		FIELD_SHOW( 3,  3, 1, _low,	"GPIO D Input"	);
		FIELD_SHOW( 2,  2, 1, _low,	"GPIO C Input"	);
		FIELD_SHOW( 1,  1, 1, _low,	"GPIO B Input"	);
		FIELD_SHOW( 0,  0, 1, _low,	"GPIO A Input"	);
	}

	return(ret);
}


